package com.huigou.uasp.builder;

import com.huigou.uasp.builder.filer.BuildApplicationFile;
import com.huigou.uasp.builder.filer.BuildControllerFile;
import com.huigou.uasp.builder.filer.BuildEntityFile;
import com.huigou.uasp.builder.filer.BuildPageDetailFile;
import com.huigou.uasp.builder.filer.BuildPageJSFile;
import com.huigou.uasp.builder.filer.BuildPageListFile;
import com.huigou.uasp.builder.filer.BuildQueryRequestFile;
import com.huigou.uasp.builder.filer.BuildRepositoryFile;
import com.huigou.uasp.builder.filer.BuildXMLFile;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("buildTypeClass")
public class BuildTypeClass {
   @Autowired
   private BuildApplicationFile buildApplicationFile;
   @Autowired
   private BuildControllerFile buildControllerFile;
   @Autowired
   private BuildEntityFile buildEntityFile;
   @Autowired
   private BuildPageDetailFile buildPageDetailFile;
   @Autowired
   private BuildPageJSFile buildPageJSFile;
   @Autowired
   private BuildPageListFile buildPageListFile;
   @Autowired
   private BuildQueryRequestFile buildQueryRequestFile;
   @Autowired
   private BuildRepositoryFile buildQueryRepositoryFile;
   @Autowired
   private BuildXMLFile buildXMLFile;

   public BuildFilerInter getBuildClass(String buildType) {
      BuildFilerInter result = null;
      switch(buildType.hashCode()) {
      case -1755807577:
         if (buildType.equals("queryRequest")) {
            result = this.buildQueryRequestFile;
            return (BuildFilerInter)result;
         }
         break;
      case -1298275357:
         if (buildType.equals("entity")) {
            result = this.buildEntityFile;
            return (BuildFilerInter)result;
         }
         break;
      case -995752936:
         if (buildType.equals("pageJS")) {
            result = this.buildPageJSFile;
            return (BuildFilerInter)result;
         }
         break;
      case 118807:
         if (buildType.equals("xml")) {
            result = this.buildXMLFile;
            return (BuildFilerInter)result;
         }
         break;
      case 637428636:
         if (buildType.equals("controller")) {
            result = this.buildControllerFile;
            return (BuildFilerInter)result;
         }
         break;
      case 843907008:
         if (buildType.equals("pageDetail")) {
            result = this.buildPageDetailFile;
            return (BuildFilerInter)result;
         }
         break;
      case 859219917:
         if (buildType.equals("pageList")) {
            result = this.buildPageListFile;
            return (BuildFilerInter)result;
         }
         break;
      case 1554253136:
         if (buildType.equals("application")) {
            result = this.buildApplicationFile;
            return (BuildFilerInter)result;
         }
         break;
      case 1950800714:
         if (buildType.equals("repository")) {
            result = this.buildQueryRepositoryFile;
            return (BuildFilerInter)result;
         }
      }

      result = null;
      return (BuildFilerInter)result;
   }
}
