package com.huigou.uasp.builder.filer;

import com.google.common.base.CaseFormat;
import com.huigou.uasp.builder.BuildFilerInter;
import com.huigou.uasp.builder.ButtonTypeInter;
import com.huigou.uasp.builder.jsbutton.AddButtonResult;
import com.huigou.uasp.builder.jsbutton.CustomButtonResult;
import com.huigou.uasp.builder.jsbutton.DeleteButtonResult;
import com.huigou.uasp.builder.jsbutton.DeleteRowButtonResult;
import com.huigou.uasp.builder.jsbutton.DisableButtonResult;
import com.huigou.uasp.builder.jsbutton.DisableButtonRowResult;
import com.huigou.uasp.builder.jsbutton.EnableButtonResult;
import com.huigou.uasp.builder.jsbutton.EnableButtonRowResult;
import com.huigou.uasp.builder.jsbutton.ExportExcelButtonResult;
import com.huigou.uasp.builder.jsbutton.SaveRowButtonResult;
import com.huigou.uasp.builder.jsbutton.UpdateButtonResult;
import com.huigou.uasp.builder.jsbutton.ViewButtonResult;
import com.huigou.uasp.builder.vo.ButtonAttributeVO;
import com.huigou.uasp.builder.vo.ParamFormVO;
import com.huigou.uasp.builder.vo.SeleListCustomVO;
import com.huigou.uasp.util.Utils;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.stereotype.Service;

@Service("buildPageJSFile")
public class BuildPageJSFile implements BuildFilerInter {
   private boolean allowEdit = false;
   private boolean doubleClick = true;
   private boolean allowNewLine = true;

   public String generateFile(ParamFormVO paraForm, List<Map<String, Object>> fieldList) throws Exception {
      String entityName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, paraForm.getTableName());
      String fileName = entityName;
      entityName = Utils.toUpperCaseFirstOne(entityName);
      StringBuffer sb = this.generateContents(paraForm, entityName, (String[])null, false, "");
      String filePathName = paraForm.getUploadPath() + "/" + paraForm.getFormPath() + "/" + fileName + "List.js";
      return Utils.generateFile(filePathName, sb);
   }

   public StringBuffer generateContents(ParamFormVO paraForm, String mainTableName, String[] mainTableFields, boolean isDetail, String queryUrl) {
      StringBuffer sb = new StringBuffer("");
      String entityName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, paraForm.getTableName());
      String fileName = entityName;
      sb.append(" var ").append(entityName).append("GridManager = null, refreshFlag = false;");
      sb.append(" $(document).ready(function () {");
      sb.append("    initUI();");
      sb.append("    init").append(Utils.toUpperCaseFirstOne(entityName)).append("ListGrid();");
      sb.append("  });");
      sb.append(" ");
      sb.append("function initUI() {");
      sb.append("    UICtrl.initDefaultLayout();");
      sb.append(" }");
      sb.append("");
      sb.append("function init").append(Utils.toUpperCaseFirstOne(entityName)).append("ListGrid() { ");
      sb.append("  var toolbarOptions =[];");
      if (paraForm.getBtnMethodNames() != null) {
         this.composeDisplayButton(paraForm, queryUrl, sb);
      }

      sb.append("");
      sb.append("  ").append(entityName).append("GridManager = UICtrl.grid('#").append(entityName).append("Grid', {");
      this.composeDisplayColumns(paraForm, queryUrl, sb);
      sb.append("       dataAction: 'server',");
      if (paraForm.getIsform() == 1) {
         if (isDetail) {
            queryUrl = "'/dataManage/slicedQueryDataRecordDetail.ajax'";
            sb.append(" parms: {formId:$(\"#formId\").val()");
            sb.append(",maiTab:'").append(mainTableName).append("'");
            sb.append(",subTab:'").append(paraForm.getTableName()).append("'");
            sb.append(",id:").append("$(\"#id\").val()");
            sb.append("},");
         } else {
            queryUrl = "'/dataManage/slicedQueryFormData.ajax'";
            sb.append(" parms: {formNo:$(\"#formNo\").val()");
            sb.append("},");
         }
      } else {
         entityName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, mainTableName);
         queryUrl = "'/" + entityName + "/slicedQuery" + entityName + ".ajax'";
         if (isDetail) {
            queryUrl = queryUrl + "&formId='+$(\"#formId\").val()";
            queryUrl = queryUrl + "+'&id='+$(\"#id\").val()";
         } else {
            entityName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, mainTableName);
            queryUrl = "'/" + fileName + "/slicedQuery" + entityName + ".ajax'";
            sb.append(" parms: {formNo:$(\"#formNo\").val()");
         }
      }

      sb.append("       url: web_app.name + ").append(queryUrl).append(",");
      if (paraForm.getBtnMethodNames() != null) {
         sb.append("       toolbar: toolbarOptions,");
      }

      sb.append("       width: '99.8%',");
      sb.append("       height: '100%',");
      sb.append("       heightDiff: -4,");
      sb.append("       sortName: 'sequence',");
      sb.append("       sortOrder: 'asc',");
      sb.append("       checkbox: true,");
      sb.append("       usePager:true,");
      sb.append("       rownumbers: false,");
      sb.append("       enabledEdit: ").append(Boolean.toString(this.allowEdit)).append(",");
      sb.append("       fixedCellHeight: true,");
      sb.append("       selectRowButtonOnly:true");
      if (isDetail) {
         sb.append("     ,onAfterEdit:bindEvent");
         sb.append("     ,autoAddRowByKeydown:true");
         sb.append("     ,onAfterAddRow:function(rows){ var id = getId(); if (id!=''){ saveRow").append(Utils.toUpperCaseFirstOne(entityName)).append("(\"\"); }  }");
      }

      sb.append("       ,onSuccess:function(data){ ");
      sb.append("         if (data.error){ Public.tip(data.error);} }");
      if (this.doubleClick) {
         sb.append("       ,onDblClickRow: function(data, rowindex, rowobj) ");
         sb.append("       { ");
         sb.append("\t         doShowUpdateDialog(data.id);");
         sb.append("       }");
      }

      sb.append("    });");
      sb.append("    UICtrl.setSearchAreaToggle(").append(entityName).append("GridManager);");
      sb.append(" \t}");
      sb.append("\r\n");
      if (isDetail) {
         Utils.composeDetailCheckFunction(paraForm, mainTableFields, sb);
      }

      sb.append(" function reload").append(Utils.toUpperCaseFirstOne(entityName)).append("Grid() {").append("     var params = $(\"#queryMainForm\").formToJSON();").append("     UICtrl.gridSearch(").append(entityName).append("GridManager, params);").append("\t}");
      sb.append("\r\n");
      sb.append("function getId() {");
      sb.append("\t    return $(\"#id\").val() || \"\";");
      sb.append("\t}");
      sb.append("\r\n");
      if (paraForm.getBtnMethodNames() != null) {
         ButtonTypeInter outResults = null;
         ButtonAttributeVO btnAttr = null;
         btnAttr = new ButtonAttributeVO();
         btnAttr.setIsForm(paraForm.getIsform());
         btnAttr.setFormName(paraForm.getFormName());
         String parentEntityName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, mainTableName);
         btnAttr.setParentEntityName(parentEntityName);
         btnAttr.setEntityName(CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, paraForm.getTableName()));

         for(int i = 0; i < paraForm.getBtnMethodNames().length; ++i) {
            btnAttr.setButtonName(paraForm.getBtnNames()[i]);
            btnAttr.setButtonMethoedName(paraForm.getBtnMethodNames()[i]);
            btnAttr.setExistAttachment(paraForm.getExistAttachment());
            btnAttr.setDataSourceType(paraForm.getDataSourceTypes());
            btnAttr.setDataSource(paraForm.getDataSources());
            btnAttr.setFieldEns(paraForm.getFieldEns());
            btnAttr.setSelectCustoms(paraForm.getSelectCustoms());
            outResults = this.getPageButtonType(paraForm.getBtnMethodNames()[i]);
            outResults.processOutResult(sb, btnAttr);
         }
      }

      sb.append("function query(obj) {");
      sb.append("  var param = $(obj).formToJSON();");
      sb.append("  UICtrl.gridSearch(").append(entityName).append("GridManager, param);");
      sb.append("}");
      sb.append("\r\n");
      sb.append("function resetForm(obj) {");
      sb.append("  $(obj).formClean();");
      sb.append("}");
      sb.append("\r\n");
      sb.append(" function onDialogCloseHandler() { ");
      sb.append("    if (refreshFlag) {");
      sb.append("        reload").append(Utils.toUpperCaseFirstOne(entityName)).append("Grid();");
      sb.append("        refreshFlag = false;");
      sb.append("    } ");
      sb.append("} ");
      String result = sb.toString();
      if (this.allowNewLine) {
         result = result.replace("{", "{\r\n");
         result = result.replace("}", "}\r\n");
         result = result.replace(";", ";\r\n");
         result = result.replace("={\r\n", "={");
         result = result.replace("}\r\n;\r\n", "};\r\n");
         result = result.replace("{\r\ndisplay:", "{display:");
      }

      return new StringBuffer(result);
   }

   public void composeDisplayColumns(ParamFormVO paraForm, String queryUrl, StringBuffer sb) {
      String[] fieldEns = paraForm.getFieldEns();
      String[] dataSourceTypes = paraForm.getDataSourceTypes();
      String[] dataSources = paraForm.getDataSources();
      String[] displayField = paraForm.getDisplayFields();
      String[] displayFieldname = paraForm.getDisplayFieldnames();
      String[] displayFieldType = paraForm.getDisplayFieldTypes();
      String[] mustInput = paraForm.getMustinputFields();
      List<SeleListCustomVO> customSqlList = paraForm.getSelectCustoms();
      String[] maxLengths = paraForm.getFieldsLengths();
      Integer[] readOnlys = paraForm.getReadOnlys();
      sb.append("      columns: [");
      double percents = 0.0D;
      if (displayField.length > 0) {
         percents = (double)(98 / displayField.length);
      }

      List<String> hideCols = new ArrayList();
      hideCols.add("id");
      String dataSourceType = "";
      String dataSource = "";
      String tagType = "input";

      int i;
      for(i = 0; i < displayField.length; ++i) {
         if (i > displayField.length - 2) {
            --percents;
         }

         for(int j = 0; j < fieldEns.length; ++j) {
            if (displayField[i].equals(fieldEns[j])) {
               tagType = paraForm.getFieldTags()[j];
               if (dataSourceTypes.length > j) {
                  dataSourceType = dataSourceTypes[j];
               }

               if (dataSources.length > j) {
                  dataSource = dataSources[j];
               }
               break;
            }
         }

         sb.append("     {display:\"" + displayFieldname[i] + "\",name:\"");
         if (paraForm.getIsform() == 1) {
            sb.append(displayField[i]).append("\"");
         } else if ("select".equals(tagType)) {
            if (this.allowEdit) {
               sb.append(displayField[i]).append("\"");
            } else {
               if (dataSource != null && !"".equals(dataSource)) {
                  sb.append(dataSource);
               } else {
                  sb.append(displayField[i]);
               }

               sb.append("TextView\"");
            }
         } else {
            sb.append(displayField[i]).append("\"");
         }

         sb.append(",width:\"" + percents + "%\",minWidth:\"60\"");
         if ("date".equalsIgnoreCase(displayFieldType[i])) {
            sb.append(",align:\"left\",type:\"date\"");
            if (this.allowEdit) {
               sb.append(",editor:{type:'date',mask:'date',");
               if ("1".equals(mustInput[i])) {
                  sb.append("required:true");
               } else {
                  sb.append("required:false");
               }

               sb.append("}");
            }
         } else if ("number".equalsIgnoreCase(displayFieldType[i])) {
            if ("select".equals(tagType)) {
               sb.append(",align:\"right\",type:\"string\"");
            } else {
               sb.append(",align:\"right\",type:\"money\"");
            }

            if (this.allowEdit) {
               sb.append(",editor:{type:'text',mask : '9999999999.99',");
               if ("1".equals(mustInput[i])) {
                  sb.append("required:true");
               } else {
                  sb.append("required:false");
               }

               sb.append("}");
            }
         } else {
            sb.append(",align:\"left\",type:\"string\"");
            if (this.allowEdit) {
               if (!"select".equals(tagType)) {
                  if (readOnlys[i] == 0) {
                     sb.append(",editor:{type: 'text',maxLength:'").append(maxLengths[i]).append("',");
                     if ("1".equals(mustInput[i])) {
                        sb.append("required:true");
                     } else {
                        sb.append("required:false");
                     }

                     sb.append("}");
                  } else {
                     sb.append(",render:function(row) { var html =\"<span style='color:blue'>\"+row.").append(displayField[i]).append("+\"</span>\"; return html;}");
                  }
               } else {
                  this.allowNewLine = false;
                  sb.append(",editor: {");
                  if ("1".equals(mustInput[i])) {
                     sb.append("required:true,");
                  } else {
                     sb.append("required:false,");
                  }

                  if ("3".equals(dataSourceType)) {
                     hideCols.add(displayField[i] + "_dictcode");
                     sb.append(" type: \"dynamic\",").append("    getEditor: function (row) {").append("    var _fieldCode = \"return {type:'select',data:{ type:'saf',name:'selectDictValueByCode',getParam:function(){ return { code:'").append(dataSource).append("' } ; },\";").append("  _fieldCode+=\"back:{name:\\\"").append(displayField[i]).append("\\\",value:\\\"").append(displayField[i]).append("_dictcode\\\" } } } \";").append("        _fieldCode = (new Function(_fieldCode))();").append("         return _fieldCode;");
                     sb.append("      }");
                     sb.append(" } ");
                  } else if ("2".equals(dataSourceType)) {
                     String[] backFields = null;
                     String[] fieldTypes = null;
                     String[] fieldCodes = null;
                     String[] paramFields = null;
                     String[] paramSourceFields = null;
                     String[] allFieldEns = null;
                     Iterator var28 = customSqlList.iterator();

                     while(var28.hasNext()) {
                        SeleListCustomVO customSqlVO = (SeleListCustomVO)var28.next();
                        if (dataSource.equals(customSqlVO.getSearchName())) {
                           hideCols.addAll(Utils.getHiddenFields(customSqlVO));
                           fieldTypes = customSqlVO.getFieldTypes().split(",");
                           backFields = customSqlVO.getBackFields().split(",");
                           fieldCodes = customSqlVO.getFieldCodes().split(",");
                           allFieldEns = customSqlVO.getFieldEns();
                           paramFields = customSqlVO.getParamFields() != null ? customSqlVO.getParamFields().split(",") : new String[0];
                           paramSourceFields = customSqlVO.getParamSourceFields() != null ? customSqlVO.getParamSourceFields().split(",") : new String[0];
                           break;
                        }
                     }

                     sb.append(" type: \"dynamic\",").append("    getEditor: function (row) {").append("    var _fieldCode = \"return {type:'select',data:{ type:'saf',name:'").append(dataSource).append("',frmType:'").append(paraForm.getFormPath()).append("',getParam:function(){ return { ");

                     int r;
                     for(r = 0; r < paramFields.length; ++r) {
                        sb.append(paramFields[r]).append(":'\"+row.").append(this.getDisplayField(allFieldEns, displayField, paramSourceFields[r])).append("+\"'");
                        if (r < paramFields.length - 1) {
                           sb.append(",");
                        }
                     }

                     sb.append(" } ; },\";").append("  _fieldCode+=\"back:{");

                     for(r = 0; r < backFields.length; ++r) {
                        if ("1".equals(fieldTypes[r])) {
                           sb.append(fieldCodes[r]).append(":\\\"").append(backFields[r]).append("\\\"");
                        } else {
                           sb.append(fieldCodes[r]).append(":\\\"").append(this.getDisplayField(allFieldEns, displayField, backFields[r])).append("\\\"");
                        }

                        if (r < backFields.length - 1) {
                           sb.append(",");
                        }
                     }

                     sb.append(" } } } \";");
                     sb.append("        _fieldCode = (new Function(_fieldCode))();").append("         return _fieldCode;");
                     sb.append("      }");
                     sb.append(" } ");
                  }
               }
            }
         }

         sb.append("},");
      }

      sb.append("{display: '状态', name: 'status', width: 50, minWidth: 40, align:\"left\",").append("render: function (item) {return UICtrl.getStatusInfo(item.status);}}");
      if (hideCols.size() > 0) {
         sb.append(",");
      }

      for(i = 0; i < hideCols.size(); ++i) {
         sb.append("   {display:\"\", name:\"").append((String)hideCols.get(i)).append("\",hide:true}");
         if (i < hideCols.size() - 1) {
            sb.append(",");
         }
      }

      sb.append("],");
   }

   public void composeDisplayButton(ParamFormVO paraForm, String queryUrl, StringBuffer sb) {
      if (paraForm.getBtnMethodNames().length > 0 && !"".equals(paraForm.getBtnMethodNames()[0])) {
         String entityName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, paraForm.getTableName());
         sb.append("  toolbarOptions = UICtrl.getDefaultToolbarOptions({");
         String mainEntityName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, paraForm.getMainTableName());

         for(int i = 0; i < paraForm.getBtnMethodNames().length; ++i) {
            if (paraForm.getBtnMethodNames()[i].indexOf("_custom") > 0) {
               sb.append("    ").append(paraForm.getBtnMethodNames()[i]).append("Handler:{  id: '").append(paraForm.getBtnMethodNames()[i]).append(i).append("',text: '").append(paraForm.getBtnNames()[i]).append("',img: 'fa-user', click: ").append(paraForm.getBtnMethodNames()[i]).append("Handler}");
            } else if ("addRow".equals(paraForm.getBtnMethodNames()[i])) {
               this.allowEdit = true;
               this.doubleClick = false;
               sb.append("addRowHandler:{").append("id:'insertRowHandler',").append("img:'fa-plus',").append("text:'添加行',").append("click:function(){ ").append("doSave").append(Utils.toUpperCaseFirstOne(mainEntityName)).append("(\"").append(entityName).append("GridManager\");").append("}").append("}");
            } else if ("deleteRow".equals(paraForm.getBtnMethodNames()[i])) {
               sb.append("    deleteRowHandler:{").append("id:'deleteRowHandler',").append("img:'fa-trash',").append("text:'删除行',").append("click:function(){").append("").append(paraForm.getBtnMethodNames()[i]).append(Utils.toUpperCaseFirstOne(entityName)).append("();").append("}").append("}");
            } else if ("saveRow".equals(paraForm.getBtnMethodNames()[i])) {
               sb.append("     saveRowHandler:{").append("id:'saveRowHandler',").append("img:'fa-upload',").append("text:'保存行',").append("click:function(){").append("").append(paraForm.getBtnMethodNames()[i]).append(Utils.toUpperCaseFirstOne(entityName)).append("(\"\");").append("}").append("}");
            } else if ("enableRow".equals(paraForm.getBtnMethodNames()[i])) {
               sb.append("     enableRowHandler:{").append("id:'enableRowHandler',").append("img:'fa-thumbs-o-up',").append("text:'启用行',").append("click:function(){").append("").append(paraForm.getBtnMethodNames()[i]).append(Utils.toUpperCaseFirstOne(entityName)).append("();").append("}").append("}");
            } else if ("disableRow".equals(paraForm.getBtnMethodNames()[i])) {
               sb.append("     disableRowHandler:{").append("id:'disableRowHandler',").append("img:'fa-thumbs-down',").append("text:'禁用行',").append("click:function(){").append("").append(paraForm.getBtnMethodNames()[i]).append(Utils.toUpperCaseFirstOne(entityName)).append("();").append("}").append("}");
            } else {
               sb.append("").append(paraForm.getBtnMethodNames()[i]).append("Handler:").append(paraForm.getBtnMethodNames()[i]).append("Handler");
            }

            if (i < paraForm.getBtnMethodNames().length - 1) {
               sb.append(",");
            }

            sb.append("");
         }

         sb.append("   });");
      }

   }

   public String getDisplayField(String[] fieldEns, String[] displayFields, String fieldName) {
      String displayField = fieldName;

      for(int j = 0; j < fieldEns.length; ++j) {
         if (fieldName.equals(fieldEns[j])) {
            displayField = displayFields[j];
            break;
         }
      }

      return displayField;
   }

   public ButtonTypeInter getPageButtonType(String condition) {
      ButtonTypeInter inter = null;
      switch(condition.hashCode()) {
      case -2118680733:
         if (condition.equals("exportExcel")) {
            inter = new ExportExcelButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case -1618913838:
         if (condition.equals("disableRow")) {
            inter = new DisableButtonRowResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case -1335458389:
         if (condition.equals("delete")) {
            inter = new DeleteButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case -1298848381:
         if (condition.equals("enable")) {
            inter = new EnableButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case -838846263:
         if (condition.equals("update")) {
            inter = new UpdateButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case -631666345:
         if (condition.equals("enableRow")) {
            inter = new EnableButtonRowResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case -358721489:
         if (condition.equals("deleteRow")) {
            inter = new DeleteRowButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case 96417:
         if (condition.equals("add")) {
            inter = new AddButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case 3619493:
         if (condition.equals("view")) {
            inter = new ViewButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case 1671308008:
         if (condition.equals("disable")) {
            inter = new DisableButtonResult();
            return (ButtonTypeInter)inter;
         }
         break;
      case 1872802589:
         if (condition.equals("saveRow")) {
            inter = new SaveRowButtonResult();
            return (ButtonTypeInter)inter;
         }
      }

      inter = new CustomButtonResult();
      return (ButtonTypeInter)inter;
   }
}
