package com.huigou.uasp.builder.filer;

import com.google.common.base.CaseFormat;
import com.huigou.uasp.builder.BuildFilerInter;
import com.huigou.uasp.builder.vo.ParamFormVO;
import com.huigou.uasp.builder.vo.SeleListCustomVO;
import com.huigou.uasp.util.Utils;
import java.io.File;
import java.util.List;
import java.util.Map;
import org.springframework.stereotype.Service;

@Service("buildXMLFile")
public class BuildXMLFile implements BuildFilerInter {
   private ParamFormVO paraForm;

   public String generateFile(ParamFormVO paraForm, List<Map<String, Object>> fieldList) throws Exception {
      File file = new File(paraForm.getUploadPath() + "/config");
      if (!file.exists()) {
         file.mkdir();
      }

      String[] filePaths = paraForm.getFormPath().split("/");
      file = new File(paraForm.getUploadPath() + "/config/" + filePaths[0]);
      if (!file.exists()) {
         file.mkdir();
      }

      String clsName = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, paraForm.getTableName());
      String fileName = clsName;
      StringBuffer sb = new StringBuffer("");
      sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n ");
      sb.append("  <query-mappings>\r\n ");
      sb.append("  \t <query name=\"").append(clsName).append("\" label=\"").append(paraForm.getFormName()).append("\" table=\"").append(paraForm.getTableName()).append("\">\r\n ");
      sb.append(" \t\t<sql-query>\r\n ");
      sb.append(" \t\t  select t.* from ").append(paraForm.getTableName()).append(" t where 1 = 1 \r\n ");
      sb.append(" \t\t</sql-query>\r\n ");
      String searchField;
      if (paraForm.getSearchFields() != null && paraForm.getSearchFields().length > 0) {
         searchField = "";

         for(int i = 0; i < paraForm.getSearchFields().length; ++i) {
            if ("1".equals(paraForm.getSearchFields()[i])) {
               searchField = paraForm.getFieldEns()[i];
               searchField = CaseFormat.UPPER_CAMEL.to(CaseFormat.LOWER_UNDERSCORE, searchField);
               if (!"date".equals(paraForm.getFieldTags()[i])) {
                  sb.append(" \t\t<condition column=\"").append(searchField).append("\" name=\"").append(paraForm.getFieldEns()[i]).append("\" type=\"java.lang.String\" symbol=\"like\" alias=\"t\"/>\r\n ");
               }
            }
         }
      }

      sb.append("    </query>\r\n ");
      sb.append("  </query-mappings>\r\n ");
      searchField = paraForm.getUploadPath() + "/config/" + filePaths[0] + "/" + clsName + ".xml";
      Utils.generateFile(searchField, sb);
      boolean existCustomSelect = false;

      for(int i = 0; i < paraForm.getDataSourceTypes().length; ++i) {
         if ("2".equals(paraForm.getDataSourceTypes()[i])) {
            existCustomSelect = true;
            break;
         }
      }

      if (existCustomSelect) {
         sb = new StringBuffer("");
         sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n ");
         sb.append("<easy-search-mappings>\r\n ");
         SeleListCustomVO selectCustom = null;
         List<SeleListCustomVO> customLists = paraForm.getSelectCustoms();

         for(int i = 0; i < paraForm.getDataSourceTypes().length; ++i) {
            if ("2".equals(paraForm.getDataSourceTypes()[i])) {
               String targetField = paraForm.getFieldEns()[i];
               selectCustom = null;

               for(int u = 0; u < customLists.size(); ++u) {
                  if (targetField.equals(((SeleListCustomVO)customLists.get(u)).getTargetField())) {
                     selectCustom = (SeleListCustomVO)customLists.get(u);
                     break;
                  }
               }

               if (selectCustom != null) {
                  fileName = "easy-search-" + selectCustom.getSearchboxType();
                  sb.append("<easy-search name=\"").append(selectCustom.getSearchName()).append("\" desc=\"").append(selectCustom.getSearchDesc()).append("\">\r\n ");
                  sb.append("<sql>\r\n ");
                  sb.append(selectCustom.getSearchSql()).append("\r\n");
                  sb.append("</sql>\r\n ");
                  String[] fieldCodes = selectCustom.getFieldCodes().split(",");
                  String[] fieldNames = selectCustom.getFieldNames().split(",");
                  String[] fieldTypes = selectCustom.getFieldTypes().split(",");
                  String[] fieldWidths = selectCustom.getFieldWidths().split(",");

                  for(int j = 0; j < fieldCodes.length; ++j) {
                     sb.append("<field name=\"").append(fieldNames[j]).append("\" code=\"").append(fieldCodes[j]).append("\"");
                     if (!"0".equals(fieldTypes[j])) {
                        sb.append(" type=\"").append(fieldTypes[j]).append("\" /> \r\n");
                     } else {
                        sb.append(" width=\"").append(fieldWidths[j]).append("\"/> \r\n");
                     }
                  }

                  if (selectCustom.getCondiColumns() != null && !"".equals(selectCustom.getCondiColumns())) {
                     String[] condiCols = selectCustom.getCondiColumns().split(",");
                     String[] condiNames = selectCustom.getCondiNames().split(",");
                     String[] condiTypes = selectCustom.getCondiTypes().split(",");
                     String[] condiSymbols = selectCustom.getCondiSymbols().split(",");
                     String[] condiAlias = selectCustom.getCondiAlias().split(",");

                     for(int x = 0; x < condiCols.length; ++x) {
                        sb.append("<condition column=\"").append(condiCols[x]).append("\" name=\"").append(condiNames[x]).append("\" type=\"").append(condiTypes[x]).append("\" symbol=\"").append(condiSymbols[x]).append("\" alias=\"").append(condiAlias[x]).append("\"/> \r\n");
                     }
                  }

                  if (selectCustom.getOrderby() != null && !"".equals(selectCustom.getOrderby())) {
                     sb.append("<orderby>").append(selectCustom.getOrderby()).append("</orderby>\r\n ");
                  }

                  sb.append("</easy-search>\r\n ");
               }
            }
         }

         sb.append("</easy-search-mappings>\r\n");
      }

      searchField = paraForm.getUploadPath() + "/config/" + filePaths[0] + "/" + fileName + ".xml";
      Utils.generateFile(searchField, sb);
      return "";
   }
}
