package com.huigou.uasp.data.controller;

import com.alibaba.fastjson.JSON;
import com.google.common.base.CaseFormat;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.builder.vo.PubDataRecord;
import com.huigou.uasp.builder.vo.SeleListCustomVO;
import com.huigou.uasp.client.CommonController;
import com.huigou.uasp.data.application.DataRecordApplication;
import com.huigou.uasp.data.domain.query.DataRecordQueryRequest;
import com.huigou.uasp.form.application.CommonUtilApplication;
import com.huigou.uasp.form.domain.model.FormAttribute;
import com.huigou.uasp.form.domain.model.SafFormslist;
import com.huigou.uasp.form.domain.query.SafFormsQueryRequest;
import com.huigou.uasp.form.repository.FormAttributeRepository;
import com.huigou.uasp.form.repository.FormSearchSqlRepository;
import com.huigou.uasp.form.repository.FormTablesRepository;
import com.huigou.uasp.form.repository.SafFormslistRepository;
import com.huigou.uasp.model.domain.query.DbTablesQueryRequest;
import com.huigou.uasp.util.ReflectionUtil;
import com.huigou.uasp.util.Utils;
import com.huigou.util.SDO;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

@Controller
@ControllerMapping({"dataManage"})
public class DataManageController extends CommonController {
   @Autowired
   private SafFormslistRepository safFormslistRepository;
   @Autowired
   private FormTablesRepository formTablesRepository;
   @Autowired
   private FormSearchSqlRepository formSearchSqlRepository;
   @Autowired
   private FormAttributeRepository formAttributeRepository;
   @Autowired
   private DataRecordApplication dataRecordApplication;
   @Autowired
   private CommonUtilApplication commonUtilApplication;

   protected String getPagePath() {
      return "/customform/";
   }

   public String slicedQueryFormData() {
      SDO sdo = this.getSDO();
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)sdo.toQueryRequest(DataRecordQueryRequest.class);
      List<SafFormslist> list = this.safFormslistRepository.findByFormNo(sdo.getString("formNo"));
      SafFormslist safFormslist = (SafFormslist)list.get(0);
      String tableName = this.commonUtilApplication.getTablesByFormId(safFormslist.getId(), 1);
      tableName = tableName.split(",")[0];
      queryRequest.setMaiTab(tableName);
      queryRequest.setSubTab(tableName);
      queryRequest.setFormId(safFormslist.getId());
      List<FormAttribute> searchList = this.formAttributeRepository.findByFormId(safFormslist.getId());
      FormAttribute formAttribute = null;
      Map<String, Object> map = new HashMap();

      for(int u = 0; u < searchList.size(); ++u) {
         formAttribute = (FormAttribute)searchList.get(u);
         if (formAttribute.getSearchField() != null && formAttribute.getSearchField() == 1) {
            map.put("field" + u, sdo.getString("field" + u));
         }
      }

      queryRequest.setSearchContent(map);
      Map<String, Object> data = this.dataRecordApplication.queryDataRecord(queryRequest);
      return this.toResult(data);
   }

   public String addDataRecord() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      String formNo = sdo.getString("formNo");
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)this.getSDO().toQueryRequest(DataRecordQueryRequest.class);
      List<SafFormslist> list = this.safFormslistRepository.findByFormNo(formNo);
      SafFormslist safFormslist = (SafFormslist)list.get(0);
      String tableName = this.commonUtilApplication.getTablesByFormId(safFormslist.getId(), 1);
      tableName = tableName.split(",")[0];
      String pageName = formNo + "/" + CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, tableName);
      queryRequest.setMaiTab(tableName);
      queryRequest.setFormId(safFormslist.getId());
      List<FormAttribute> attrList = this.formAttributeRepository.findByFormIdAndTable(safFormslist.getId(), tableName.toUpperCase());
      new HashMap();
      int u = 0;

      FormAttribute formAttribute;
      for(Iterator var13 = attrList.iterator(); var13.hasNext(); ++u) {
         formAttribute = (FormAttribute)var13.next();
         if (formAttribute.getDataSourceType() != null && "4".equals(formAttribute.getDataSourceType())) {
            new HashMap();
            if (formAttribute.getDataSource() != null) {
               Map<String, Object> mapData = (Map)JSON.parse(formAttribute.getDataSource());
               this.putAttribute("field" + u + "_" + formAttribute.getFieldTag(), mapData);
            }
         }
      }

      formAttribute = null;
      PubDataRecord entity;
      if (StringUtils.isEmpty(id)) {
         entity = new PubDataRecord();
         entity.setFormId(safFormslist.getId());
         entity = this.dataRecordApplication.loadDataRecordByAdded(queryRequest);
      } else {
         entity = this.dataRecordApplication.loadDataRecord(queryRequest);
      }

      entity.setFormId(safFormslist.getId());
      Map<String, Object> map = entity.getHiddField();
      if (map != null) {
         Iterator var15 = map.entrySet().iterator();

         while(var15.hasNext()) {
            Entry<String, Object> entry = (Entry)var15.next();
            this.putAttribute((String)entry.getKey(), entry.getValue());
         }
      }

      return this.forward(pageName, entity);
   }

   public String saveDataRecord() {
      SDO sdo = this.getSDO();
      PubDataRecord entity = (PubDataRecord)sdo.toObject(PubDataRecord.class);
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)this.getSDO().toQueryRequest(DataRecordQueryRequest.class);
      SafFormslist form = (SafFormslist)this.safFormslistRepository.findOne(sdo.getString("formId"));
      List<Map<String, Object>> dataList = new ArrayList();
      SafFormsQueryRequest safFormsQueryRequest = new SafFormsQueryRequest();
      safFormsQueryRequest.setId(form.getId());
      String tableName = this.commonUtilApplication.getTablesByFormId(form.getId(), 1);
      tableName = tableName.split(",")[0];
      queryRequest.setMaiTab(tableName);
      queryRequest.setFormId(form.getId());
      queryRequest.setFormNo(form.getFormNo());
      List<Map<String, Object>> fieldList = this.commonUtilApplication.queryDataRecordSingleFields(safFormsQueryRequest.getId(), tableName.toUpperCase());
      Map<String, Object> map = Utils.dataValueTransfer(fieldList, entity);
      new ArrayList();
      DbTablesQueryRequest dbqueryRequest = new DbTablesQueryRequest();
      dbqueryRequest.setTableName(tableName.toUpperCase());
      List<String> hiddenFields = this.commonUtilApplication.queryTableHiddenFields(dbqueryRequest, 0);
      queryRequest.setHiddenField(hiddenFields);
      String vals = "";
      String tempHiddenStr = "";
      Iterator var15 = hiddenFields.iterator();

      while(var15.hasNext()) {
         String hiddenStr = (String)var15.next();
         tempHiddenStr = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, hiddenStr);
         if (StringUtils.isNotBlank(sdo.getString(tempHiddenStr))) {
            vals = sdo.getString(tempHiddenStr);
            map.put(hiddenStr, vals);
         }
      }

      if (entity.getId() != null) {
         map.put("id", entity.getId());
      }

      dataList.add(map);
      List<PubDataRecord> list = this.dataRecordApplication.saveDataRecord(queryRequest, dataList);
      entity = (PubDataRecord)list.get(list.size() - 1);
      String methods = "";
      if (!"".equals(methods)) {
         return this.success(entity.getId() + ";" + methods);
      } else {
         return this.success(entity.getId());
      }
   }

   public String deleteDataRecord() {
      SDO sdo = this.getSDO();
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)sdo.toQueryRequest(DataRecordQueryRequest.class);
      List<SafFormslist> list = this.safFormslistRepository.findByFormNo(sdo.getString("formNo"));
      SafFormslist safFormslist = (SafFormslist)list.get(0);
      String tableName = this.commonUtilApplication.getTablesByFormId(safFormslist.getId(), 1);
      tableName = tableName.split(",")[0];
      String subTableName = this.commonUtilApplication.getTablesByFormId(safFormslist.getId(), 2);
      queryRequest.setMaiTab(tableName);
      queryRequest.setSubTab(subTableName);
      queryRequest.setFormId(safFormslist.getId());
      Map<String, Object> data = new HashMap();
      this.dataRecordApplication.deleteDataRecord(queryRequest, this.getSDO().getIds());
      return this.toResult(data);
   }

   public String deleteDataRecordDetail() {
      SDO sdo = this.getSDO();
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)sdo.toQueryRequest(DataRecordQueryRequest.class);
      this.dataRecordApplication.deleteDataRecordDetail(queryRequest, sdo.getString("ids"));
      Map<String, Object> data = new HashMap();
      return this.toResult(data);
   }

   public String slicedQueryDataRecordDetail() {
      SDO sdo = this.getSDO();
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)sdo.toQueryRequest(DataRecordQueryRequest.class);
      Map<String, Object> data = new HashMap();
      SafFormslist safFormslist = (SafFormslist)this.safFormslistRepository.findOne(queryRequest.getFormId());
      queryRequest.setFormNo(safFormslist.getFormNo());
      List<String> hiddenFieldList = this.getDetailHiddenFields(queryRequest);
      queryRequest.setHiddenField(hiddenFieldList);
      if (!StringUtils.isEmpty(sdo.getString("id"))) {
         if (this.dataRecordApplication.queryIsExistTable(queryRequest) == 0) {
            ((Map)data).put("error", queryRequest.getSubTab() + "表不存在！");
         } else {
            data = this.dataRecordApplication.queryDataRecordDetail(queryRequest);
         }
      }

      return this.toResult(data);
   }

   public String saveRowDataRecordDetail() {
      SDO sdo = this.getSDO();
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)sdo.toQueryRequest(DataRecordQueryRequest.class);
      SafFormslist safFormslist = (SafFormslist)this.safFormslistRepository.findOne(queryRequest.getFormId());
      List<PubDataRecord> detailData = sdo.getList("detailData", PubDataRecord.class);
      List<PubDataRecord> newDetailData = new ArrayList();
      List<Object> listold = sdo.getList("detailData");
      String subTable = CaseFormat.UPPER_CAMEL.to(CaseFormat.LOWER_UNDERSCORE, queryRequest.getSubTab());
      DbTablesQueryRequest dbqueryRequest = new DbTablesQueryRequest();
      dbqueryRequest.setTableName(subTable.toUpperCase());
      List<String> hiddenFieldList = this.commonUtilApplication.queryTableHiddenFields(dbqueryRequest, 0);
      queryRequest.setFormNo(safFormslist.getFormNo());
      PubDataRecord entity = null;
      Map<String, Object> map = null;
      Map<String, Object> hiddenMap = null;
      String field = "";

      for(int i = 0; i < listold.size(); ++i) {
         map = (Map)listold.get(i);
         entity = (PubDataRecord)detailData.get(i);
         boolean allEmptyVal = true;
         Iterator var17 = map.entrySet().iterator();

         Entry entry;
         while(var17.hasNext()) {
            entry = (Entry)var17.next();
            if (((String)entry.getKey()).toString().startsWith("field") && !"".equals(entry.getValue().toString())) {
               allEmptyVal = false;
               break;
            }
         }

         if (!allEmptyVal) {
            hiddenMap = new HashMap();
            var17 = map.entrySet().iterator();

            while(true) {
               while(var17.hasNext()) {
                  entry = (Entry)var17.next();
                  if (((String)entry.getKey()).toString().endsWith("_dictcode")) {
                     field = ((String)entry.getKey()).toString();
                     field = field.substring(0, field.length() - 9);
                     ReflectionUtil.invokeSet(entity, field, entry.getValue());
                  } else if (!((String)entry.getKey()).toString().startsWith("field")) {
                     field = ((String)entry.getKey()).toString();
                     if (entry.getValue() != null && !"".equals(entry.getValue())) {
                        Iterator var19 = hiddenFieldList.iterator();

                        while(var19.hasNext()) {
                           String hiddenField = (String)var19.next();
                           field = CaseFormat.UPPER_CAMEL.to(CaseFormat.LOWER_UNDERSCORE, field);
                           if (field.equals(hiddenField)) {
                              hiddenMap.put(field, entry.getValue());
                           }
                        }
                     }
                  }
               }

               entity.setHiddField(hiddenMap);
               newDetailData.add(entity);
               break;
            }
         }
      }

      Map<String, Object> data = new HashMap();
      if (!StringUtils.isEmpty(sdo.getString("id"))) {
         String backStr = this.dataRecordApplication.saveDataRecordDetail(queryRequest, hiddenFieldList, newDetailData);
         data.put("result", backStr);
      }

      return this.toResult(data);
   }

   public List<String> getDetailHiddenFields(DataRecordQueryRequest queryRequest) {
      List<Map<String, Object>> hiddenList = this.dataRecordApplication.queryHiddenFieldBySearchSQL(queryRequest);
      List<String> hiddenFieldList = new ArrayList();
      if (hiddenList.size() > 0) {
         SeleListCustomVO customVO = null;
         Iterator var6 = hiddenList.iterator();

         while(var6.hasNext()) {
            Map<String, Object> map = (Map)var6.next();
            customVO = new SeleListCustomVO();
            customVO.setBackFields(map.get("backFields").toString());
            customVO.setFieldTypes(map.get("fieldTypes").toString());
            hiddenFieldList.addAll(Utils.getHiddenFields(customVO));
         }
      }

      return hiddenFieldList;
   }

   public String changeDataRecordStatus() {
      SDO sdo = this.getSDO();
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)sdo.toQueryRequest(DataRecordQueryRequest.class);
      String tableName = this.commonUtilApplication.getTablesByFormId(sdo.getString("id"), 1);
      tableName = tableName.split(",")[0];
      queryRequest.setMaiTab(tableName);
      this.dataRecordApplication.changeDataRecordStatus(queryRequest);
      return this.success();
   }

   public String changeDataRecordDetailStatus() {
      SDO sdo = this.getSDO();
      DataRecordQueryRequest queryRequest = (DataRecordQueryRequest)sdo.toQueryRequest(DataRecordQueryRequest.class);
      this.dataRecordApplication.changeDataRecordDetailStatus(queryRequest);
      return this.success();
   }

   public String checkFieldFunction() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      String currVal = sdo.getString("currVal");
      String funcname = sdo.getString("funcname");
      String paramfields = sdo.getString("paramfield");
      Map<String, Object> map = new HashMap();
      map.put("funcname", funcname);
      map.put("paramfields", paramfields);
      map.put("currVal", currVal);
      map.put("id", id);
      if (!"".equals(paramfields)) {
         map.put("paramfields", paramfields);
         String[] paramfield = paramfields.split(",");
         String[] var11 = paramfield;
         int var10 = paramfield.length;

         for(int var9 = 0; var9 < var10; ++var9) {
            String pafield = var11[var9];
            map.put(pafield, sdo.getString(pafield));
         }
      }

      String backStr = this.dataRecordApplication.checkFieldFunction(map);
      Map<String, Object> backmap = new HashMap();
      backmap.put("flag", "0");
      if (backStr.startsWith("success")) {
         backStr = backStr.replace("success:", "");
         backmap.put("flag", "1");
      }

      backmap.put("result", backStr);
      return this.toResult(backmap);
   }
}
