package com.huigou.uasp.data.controller;

import com.google.common.base.CaseFormat;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.client.CommonController;
import com.huigou.uasp.data.application.DataRecordApplication;
import com.huigou.uasp.form.application.CommonUtilApplication;
import com.huigou.uasp.form.domain.model.SafFormslist;
import com.huigou.uasp.form.repository.FormTablesRepository;
import com.huigou.uasp.form.repository.SafFormslistRepository;
import com.huigou.util.SDO;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

@Controller
@ControllerMapping({"menuManage"})
public class MenuManageController extends CommonController {
   @Autowired
   private SafFormslistRepository safFormslistRepository;
   @Autowired
   private FormTablesRepository formTablesRepository;
   @Autowired
   private DataRecordApplication dataRecordApplication;
   @Autowired
   private CommonUtilApplication commonUtilApplication;

   protected String getPagePath() {
      return "/customform/";
   }

   public String forwardPageList() {
      SDO sdo = this.getSDO();
      String olddata = "0";
      if ("1".equals(sdo.getString("olddata"))) {
         olddata = "1";
      }

      String formNo = sdo.getString("formNo");
      List<SafFormslist> list = this.safFormslistRepository.findByFormNo(formNo);
      SafFormslist safFormslist = (SafFormslist)list.get(0);
      String tableName = this.commonUtilApplication.getTablesByFormId(safFormslist.getId(), 1);
      tableName = tableName.split(",")[0];
      String pageName = "/" + formNo + "/" + CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, tableName) + "List";
      this.putAttribute("formNo", formNo);
      return this.forward(pageName);
   }
}
