package com.huigou.uasp.form.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huigou.cache.DictUtil;
import com.huigou.cache.SystemCache;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.annotation.SkipAuth;
import com.huigou.uasp.client.CommonController;
import com.huigou.uasp.form.application.CommonUtilApplication;
import com.huigou.uasp.form.application.FormsDesignApplication;
import com.huigou.uasp.form.application.SafFormslistApplication;
import com.huigou.uasp.form.domain.model.FormSearchSql;
import com.huigou.uasp.form.domain.model.SafFormslist;
import com.huigou.uasp.form.domain.query.FormsAttributeQueryRequest;
import com.huigou.uasp.form.domain.query.SafFormsQueryRequest;
import com.huigou.uasp.form.pojo.Root;
import com.huigou.uasp.form.pojo.RootBean;
import com.huigou.uasp.form.pojo.TableColumns;
import com.huigou.uasp.form.pojo.analysis.PublicAnalysis;
import com.huigou.uasp.form.repository.FormAttributeRepository;
import com.huigou.uasp.form.repository.FormSearchSqlRepository;
import com.huigou.uasp.form.repository.FormTablesRepository;
import com.huigou.uasp.form.repository.SafFormslistRepository;
import com.huigou.util.SDO;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.ezmorph.bean.MorphDynaBean;
import org.apache.commons.beanutils.DynaProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@Controller
@ControllerMapping({"formDesign"})
public class FormDesignController extends CommonController {
   @Autowired
   private SafFormslistRepository safFormslistRepository;
   @Autowired
   private FormTablesRepository formTablesRepository;
   @Autowired
   private FormAttributeRepository formAttributeRepository;
   @Autowired
   private FormSearchSqlRepository formSearchSqlRepository;
   @Autowired
   private CommonUtilApplication commonUtilApplication;
   @Autowired
   private SafFormslistApplication safFormsApplication;
   @Autowired
   private FormsDesignApplication formsDesignApplication;

   protected String getPagePath() {
      return "/formdesign/resource/js/ueditor/formdesign/";
   }

   @SkipAuth
   public String forwardFormDesignPage() {
      SDO sdo = this.getSDO();
      String formNo = sdo.getString("formNo");
      String pageType = sdo.getString("pageType");
      List<SafFormslist> formList = this.safFormslistRepository.findByFormNo(formNo);
      SafFormslist form = (SafFormslist)formList.get(0);
      String tableName = this.commonUtilApplication.getTablesByFormId(form.getId(), 1);
      tableName = tableName.split(",")[0];
      List<Map<String, Object>> fieldLists = this.commonUtilApplication.queryFormTableFields(formNo, tableName);
      this.putAttribute("fieldLists", JSONObject.toJSON(fieldLists));
      return this.forward(pageType);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getmainfields"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getMainFields(HttpServletRequest request, HttpServletResponse response) {
      net.sf.json.JSONObject backData = new net.sf.json.JSONObject();
      String formNo = request.getParameter("formno");
      String datas = "";

      try {
         PrintWriter out = response.getWriter();
         if (formNo == null) {
            datas = URLEncoder.encode("缺少参数formno!", "UTF-8");
            backData.put("reason", datas);
            out.println(backData.toString());
            out.close();
         } else {
            List<SafFormslist> formList = this.safFormslistRepository.findByFormNo(formNo);
            SafFormslist form = (SafFormslist)formList.get(0);
            String tableName = this.commonUtilApplication.getTablesByFormId(form.getId(), 1);
            tableName = tableName.split(",")[0];
            List<Map<String, Object>> fieldLists = this.commonUtilApplication.queryFormTableFields(formNo, tableName);
            datas = JSON.toJSONString(fieldLists);
         }
      } catch (Exception var11) {
         var11.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getalltables"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getAllTables(HttpServletRequest request, HttpServletResponse response) {
      net.sf.json.JSONObject backData = new net.sf.json.JSONObject();
      String formNo = request.getParameter("formno");
      String datas = "";

      try {
         PrintWriter out = response.getWriter();
         if (formNo == null) {
            datas = "缺少参数formno!";
            backData.put("reason", datas);
            out.println(backData.toString());
            out.close();
         } else {
            SafFormsQueryRequest queryRequest = new SafFormsQueryRequest();
            queryRequest.setFormNo(formNo);
            List<Map<String, Object>> tableList = this.safFormsApplication.queryExistTables(queryRequest);
            datas = JSON.toJSONString(tableList);
         }
      } catch (Exception var9) {
         var9.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getfields"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getFields(HttpServletRequest request, HttpServletResponse response) {
      net.sf.json.JSONObject backData = new net.sf.json.JSONObject();
      String formNo = request.getParameter("formno");
      String tableName = request.getParameter("tablename");
      String datas = "";

      try {
         PrintWriter out = response.getWriter();
         if (formNo == null) {
            datas = "缺少参数formno!";
            backData.put("reason", datas);
            out.println(backData.toString());
            out.close();
         } else if (tableName == null) {
            datas = "缺少参数tablename!";
            backData.put("reason", datas);
            out.println(backData.toString());
            out.close();
         } else {
            List<Map<String, Object>> fieldLists = this.commonUtilApplication.queryFormTableFields(formNo, tableName);
            datas = JSON.toJSONString(fieldLists);
         }
      } catch (Exception var9) {
         var9.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getsearchsql"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getSearchSql(HttpServletRequest request, HttpServletResponse response) {
      net.sf.json.JSONObject backData = new net.sf.json.JSONObject();
      String formNo = request.getParameter("formno");
      String datas = "";

      try {
         PrintWriter out = response.getWriter();
         if (formNo == null) {
            datas = "缺少参数formno!";
            backData.put("reason", datas);
            out.println(backData.toString());
            out.close();
         } else {
            List<FormSearchSql> sqllist = this.formSearchSqlRepository.searchSqlByFormNo(formNo);
            datas = JSON.toJSONString(sqllist);
         }
      } catch (Exception var8) {
         var8.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getformjson"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getTestData(HttpServletRequest request, HttpServletResponse response) {
      net.sf.json.JSONObject backData = new net.sf.json.JSONObject();
      String formNo = request.getParameter("formno");
      String datas = "";

      try {
         PrintWriter out = response.getWriter();
         if (formNo == null) {
            datas = "缺少参数formNo!";
            backData.put("reason", datas);
            out.println(backData.toString());
            out.close();
         } else {
            List<SafFormslist> formList = this.safFormslistRepository.findByFormNo(formNo);
            if (formList != null && formList.size() > 0) {
               datas = ((SafFormslist)formList.get(0)).getJson();
            } else {
               datas = "表单编号" + formNo + "不存在!";
               backData.put("reason", datas);
               out.println(backData.toString());
               out.close();
            }
         }
      } catch (Exception var8) {
         var8.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getdatadict"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getDataDict(HttpServletRequest request, HttpServletResponse response) {
      new net.sf.json.JSONObject();
      String datas = "";
      PrintWriter out = null;

      try {
         out = response.getWriter();
         String dictFolderName = (String)SystemCache.getParameter("formDictFolderName", String.class);
         List<Map<String, Object>> datalist = this.formsDesignApplication.getFormDataDict(dictFolderName);
         datas = JSON.toJSONString(datalist);
      } catch (Exception var8) {
         out.println(var8.getMessage());
         out.close();
         var8.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getdbobject"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getDBFunctions(HttpServletRequest request, HttpServletResponse response) {
      String datas = "";
      PrintWriter out = null;
      String type = request.getParameter("type");

      try {
         out = response.getWriter();
         if ("func".equals(type)) {
            type = "FUNCTION";
         } else if ("proc".equals(type)) {
            type = "PROCEDURE";
         }

         List<Map<String, Object>> datalist = this.formsDesignApplication.getDBFunctionsOrProceduce(type);
         datas = JSON.toJSONString(datalist);
      } catch (Exception var7) {
         out.println(var7.getMessage());
         out.close();
         var7.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/getfieldtype"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String getFieldType(HttpServletRequest request, HttpServletResponse response) {
      String datas = "";
      PrintWriter out = null;

      try {
         out = response.getWriter();
         List<Map<String, Object>> datalist = DictUtil.getDictionaryList("validatorType");
         datas = JSON.toJSONString(datalist);
      } catch (Exception var6) {
         out.println(var6.getMessage());
         out.close();
         var6.printStackTrace();
      }

      return this.toResult(datas);
   }

   @SkipAuth
   @RequestMapping(
      value = {"/saveform"},
      method = {RequestMethod.POST, RequestMethod.GET}
   )
   public String saveFormData(HttpServletRequest request, HttpServletResponse response) {
      net.sf.json.JSONObject backData = new net.sf.json.JSONObject();
      Map<String, Object> map = new HashMap();
      String formNo = request.getParameter("formno");
      String contents = request.getParameter("datas");
      String datas = "";

      try {
         System.out.println(formNo + "==========" + contents);
         PrintWriter out = response.getWriter();
         if (formNo == null) {
            datas = "缺少参数formNo!";
            backData.put("reason", datas);
            out.println(backData.toString());
            out.close();
         } else if (contents == null) {
            datas = "缺少参数datas!";
            backData.put("reason", datas);
            contents = "{\"list\":[{\"type\":\"table\",\"tablename\":\"SMS_ORDER_DETAIL\",\"icon\":\"icon-table\",\"options\":{\"defaultValue\":[],\"customClass\":\"\",\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"disabled\":false,\"required\":false,\"remoteFunc\":\"func_1592183795541\",\"remoteOption\":\"option_1592183795541\"},\"tableColumns\":[{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"200px\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592183804092\",\"remoteOption\":\"option_1592183804092\",\"tableColumn\":true},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"订单编号\",\"novalid\":{},\"key\":\"1592183804092\",\"model\":\"order_num\",\"rules\":[],\"table\":\"SMS_ORDER_DETAIL\"},{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"200px\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592183830591\",\"remoteOption\":\"option_1592183830591\",\"tableColumn\":true},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"名称\",\"novalid\":{},\"key\":\"1592183830591\",\"model\":\"name\",\"rules\":[],\"table\":\"SMS_ORDER_DETAIL\"},{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"200px\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592183846416\",\"remoteOption\":\"option_1592183846416\",\"tableColumn\":true},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"联系人\",\"novalid\":{},\"key\":\"1592183846416\",\"model\":\"linkman\",\"rules\":[],\"table\":\"SMS_ORDER_DETAIL\"},{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"200px\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592183862642\",\"remoteOption\":\"option_1592183862642\",\"tableColumn\":true},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"单价\",\"novalid\":{},\"key\":\"1592183862642\",\"model\":\"unit_price\",\"rules\":[],\"table\":\"SMS_ORDER_DETAIL\"},{\"type\":\"date\",\"icon\":\"icon-date\",\"options\":{\"defaultValue\":\"\",\"readonly\":false,\"disabled\":false,\"editable\":true,\"clearable\":true,\"placeholder\":\"\",\"startPlaceholder\":\"\",\"endPlaceholder\":\"\",\"type\":\"date\",\"format\":\"yyyy-MM-dd\",\"timestamp\":false,\"required\":false,\"requiredMessage\":\"\",\"width\":\"200px\",\"customClass\":\"\",\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"remoteFunc\":\"func_1592793103693\",\"remoteOption\":\"option_1592793103693\",\"tableColumn\":true},\"table\":\"SMS_ORDER_DETAIL\",\"event\":{\"change\":\"\"},\"name\":\"日期\",\"novalid\":{},\"key\":\"1592793103693\",\"model\":\"entry_date\",\"rules\":[]}],\"name\":\"\",\"key\":\"1592183795541\",\"model\":\"table_1592183795541\",\"rules\":[]},{\"type\":\"grid\",\"icon\":\"icon-RectangleCopy\",\"columns\":[{\"span\":12,\"xs\":12,\"sm\":12,\"md\":12,\"lg\":12,\"xl\":12,\"list\":[{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"100%\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592184027111\",\"remoteOption\":\"option_1592184027111\"},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"名称\",\"novalid\":{},\"key\":\"1592184027111\",\"model\":\"name\",\"rules\":[],\"table\":\"SMS_ORDER\"},{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"100%\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592793011673\",\"remoteOption\":\"option_1592793011673\"},\"table\":\"SMS_ORDER\",\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"允许\",\"novalid\":{},\"key\":\"1592793011673\",\"model\":\"key\",\"rules\":[]},{\"type\":\"easy_search\",\"icon\":\"icon-easy-search\",\"options\":{\"defaultValue\":\"SearchBox\",\"customClass\":\"\",\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"disabled\":false,\"required\":false,\"options\":[{\"value\":\"TreeBox\",\"options\":[{\"type\":\"\",\"name\":\"\",\"searchType\":\"\",\"nodeName\":\"\",\"treeLeafOnly\":\"\",\"param\":\"\"}]},{\"value\":\"SearchBox\",\"options\":[{\"queryName\":\"selectConstructUnits\"}]}],\"remoteFunc\":\"func_1592797861100\",\"remoteOption\":\"option_1592797861100\"},\"table\":\"SMS_ORDER\",\"name\":\"管理者\",\"novalid\":{},\"key\":\"1592797861100\",\"model\":\"manager\",\"rules\":[]}]},{\"span\":12,\"xs\":12,\"sm\":12,\"md\":12,\"lg\":12,\"xl\":12,\"list\":[{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"100%\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592184045106\",\"remoteOption\":\"option_1592184045106\"},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"性别\",\"novalid\":{},\"key\":\"1592184045106\",\"model\":\"sex\",\"rules\":[],\"table\":\"SMS_ORDER\"}]}],\"options\":{\"gutter\":0,\"justify\":\"start\",\"align\":\"top\",\"customClass\":\"\",\"hidden\":false,\"flex\":true,\"responsive\":false,\"remoteFunc\":\"func_1592184014765\",\"remoteOption\":\"option_1592184014765\"},\"name\":\"栅格布局\",\"key\":\"1592184014765\",\"model\":\"grid_1592184014765\",\"rules\":[]},{\"type\":\"checkbox\",\"icon\":\"icon-check-box\",\"options\":{\"inline\":false,\"defaultValue\":[],\"showLabel\":false,\"options\":[{\"value\":\"Option 1\"},{\"value\":\"Option 2\"},{\"value\":\"Option 3\"}],\"required\":false,\"requiredMessage\":\"\",\"width\":\"\",\"remote\":true,\"remoteType\":\"dictionary\",\"remoteOption\":\"option_1593328433319\",\"remoteOptions\":[],\"props\":{\"value\":\"value\",\"label\":\"label\"},\"remoteFunc\":\"func_1593328433319\",\"customClass\":\"\",\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"disabled\":false,\"dictionary\":\"unit\"},\"table\":\"\",\"event\":{\"change\":\"\"},\"name\":\"多选框组\",\"key\":\"1593328433319\",\"model\":\"checkbox_1593328433319\",\"rules\":[]},{\"type\":\"radio\",\"icon\":\"icon-radio-active\",\"options\":{\"inline\":false,\"defaultValue\":\"\",\"showLabel\":false,\"options\":[{\"value\":\"Option 1\",\"label\":\"Option 1\"},{\"value\":\"Option 2\",\"label\":\"Option 2\"},{\"value\":\"Option 3\",\"label\":\"Option 3\"}],\"required\":false,\"requiredMessage\":\"\",\"width\":\"\",\"remote\":true,\"remoteType\":\"dictionary\",\"remoteOption\":\"option_1593328287179\",\"remoteOptions\":[],\"props\":{\"value\":\"value\",\"label\":\"label\"},\"remoteFunc\":\"func_1593328287179\",\"customClass\":\"\",\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"disabled\":false,\"dictionary\":\"sex2\"},\"table\":\"SMS_ORDER\",\"event\":{\"change\":\"\"},\"name\":\"允许2\",\"key\":\"1593328287179\",\"model\":\"key2\",\"rules\":[]},{\"type\":\"input\",\"icon\":\"icon-input\",\"options\":{\"width\":\"30%\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"dataType\":\"\",\"dataTypeCheck\":false,\"dataTypeMessage\":\"\",\"pattern\":\"\",\"patternCheck\":false,\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"disabled\":false,\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"showPassword\":false,\"remoteFunc\":\"func_1592296098724\",\"remoteOption\":\"option_1592296098724\"},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"型号\",\"key\":\"1592296098724\",\"model\":\"style\",\"rules\":[],\"table\":\"SMS_ORDER\"},{\"type\":\"textarea\",\"icon\":\"icon-diy-com-textarea\",\"options\":{\"width\":\"30%\",\"defaultValue\":\"\",\"required\":false,\"requiredMessage\":\"\",\"disabled\":false,\"pattern\":\"\",\"patternMessage\":\"\",\"placeholder\":\"\",\"customClass\":\"\",\"labelWidth\":100,\"isLabelWidth\":false,\"hidden\":false,\"dataBind\":true,\"remoteFunc\":\"func_1592296110884\",\"remoteOption\":\"option_1592296110884\"},\"event\":{\"blur\":\"\",\"change\":\"\"},\"name\":\"备注\",\"key\":\"1592296110884\",\"model\":\"remark\",\"rules\":[],\"table\":\"SMS_ORDER\"}],\"config\":{\"labelWidth\":100,\"labelPosition\":\"right\",\"size\":\"small\",\"customClass\":\"\",\"ui\":\"element\",\"layout\":\"horizontal\",\"labelCol\":3,\"width\":\"100%\"}}";
         }

         net.sf.json.JSONObject jsonObject = net.sf.json.JSONObject.fromObject(contents);
         RootBean resultInfo = (RootBean)net.sf.json.JSONObject.toBean(jsonObject, RootBean.class);
         List<SafFormslist> formList = this.safFormslistRepository.findByFormNo(formNo);
         SafFormslist form = (SafFormslist)formList.get(0);
         String mainTableName = this.commonUtilApplication.getTablesByFormId(form.getId(), 1);
         mainTableName = mainTableName.split(",")[0].toUpperCase();
         System.out.println("===开始解析Json=================");
         List<?> dataList = resultInfo.getList();
         MorphDynaBean mbean = null;
         List<Root> rootList = new ArrayList();
         Root root = null;
         DynaProperty[] dynaProperties = null;
         List<TableColumns> tableColumnsList = null;

         for(int i = 0; i < dataList.size(); ++i) {
            mbean = (MorphDynaBean)dataList.get(i);
            tableColumnsList = new ArrayList();
            root = new Root();
            dynaProperties = mbean.getDynaClass().getDynaProperties();

            for(int j = 0; j < dynaProperties.length; ++j) {
               String attrName = dynaProperties[j].getName();
               PublicAnalysis.getAttrNameType(attrName).getRootByAttrName(attrName, root, mbean, tableColumnsList);
            }

            rootList.add(root);
         }

         FormsAttributeQueryRequest queryRequest = new FormsAttributeQueryRequest();
         queryRequest.setId(form.getId());
         queryRequest.setFormNo(formNo);
         queryRequest.setRootList(rootList);
         queryRequest.setJson(contents);
         queryRequest.setTableName(mainTableName);
         Map<String, Object> bakmap = this.formsDesignApplication.saveFormAttribute(queryRequest, form);
         if ("1".equals(bakmap.get("success").toString())) {
            map.put("success", "1");
            SafFormsQueryRequest formQueryRequest = new SafFormsQueryRequest();
            formQueryRequest.setId(form.getId());
            formQueryRequest.setFormNo(formNo);
            formQueryRequest.setTableName(mainTableName);
            this.safFormsApplication.needGenerateFile(formQueryRequest);
         } else {
            map.put("reason", bakmap.get("reason"));
         }

         map.put("success", "1");
      } catch (Exception var23) {
         map.put("success", "0");
         map.put("reason", var23.getMessage());
         var23.printStackTrace();
      }

      return this.toResult(map);
   }

   protected void renderData(HttpServletResponse response, String data) {
      PrintWriter printWriter = null;

      try {
         printWriter = response.getWriter();
         printWriter.print(data);
      } catch (IOException var8) {
      } finally {
         if (printWriter != null) {
            printWriter.flush();
            printWriter.close();
         }

      }

   }
}
