package com.huigou.uasp.form.domain.model;

import com.huigou.data.domain.listener.CreatorAndModifierListener;
import com.huigou.data.domain.model.AbstractEntity;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.Table;
import javax.persistence.Transient;

@Entity
@Table(
   name = "SAF_FORM_ATTRIBUTE"
)
@EntityListeners({CreatorAndModifierListener.class})
public class FormAttribute extends AbstractEntity {
   private static final long serialVersionUID = 1L;
   @Column(
      name = "form_id",
      length = 32
   )
   private String formId;
   @Column(
      name = "meta_id",
      length = 100
   )
   private String metaId;
   @Column(
      name = "attr_name",
      length = 100
   )
   private String attrName;
   @Column(
      name = "attr_code",
      length = 100
   )
   private String attrCode;
   @Column(
      name = "remark",
      length = 1000
   )
   private String remark;
   @Column(
      name = "css_style",
      length = 1000
   )
   private String cssStyle;
   @Column(
      name = "check_function",
      length = 500
   )
   private String checkFunction;
   @Column(
      name = "js_function",
      length = 1000
   )
   private String jsFunction;
   @Column(
      name = "data_source_type",
      length = 10
   )
   private String dataSourceType;
   @Column(
      name = "data_source",
      length = 1000
   )
   private String dataSource;
   @Column(
      name = "must_input",
      length = 22
   )
   private Integer mustInput;
   @Column(
      name = "default_value",
      length = 200
   )
   private String defaultValue;
   @Column(
      name = "data_format",
      length = 50
   )
   private String dataFormat;
   @Column(
      name = "field_tag",
      length = 50
   )
   private String fieldTag;
   @Column(
      name = "display_listing",
      length = 22
   )
   private Integer displayListing;
   @Column(
      name = "table_type",
      length = 10
   )
   private Integer tableType;
   @Column(
      name = "table_name",
      length = 40
   )
   private String tableName;
   @Column(
      name = "max_length",
      length = 10
   )
   private Integer maxLength;
   @Column(
      name = "search_field",
      length = 22
   )
   private Integer searchField;
   @Column(
      name = "sequence",
      length = 22
   )
   private Integer sequence;
   @Column(
      name = "status",
      length = 22
   )
   private Integer status;
   @Column(
      name = "read_only",
      length = 10
   )
   private Integer readOnly;
   @Column(
      name = "created_date",
      length = 20
   )
   private Date createdDate;
   @Transient
   private String isOld;

   public String getAttrCode() {
      return this.attrCode;
   }

   public void setAttrCode(String attrCode) {
      this.attrCode = attrCode;
   }

   public String getRemark() {
      return this.remark;
   }

   public void setRemark(String remark) {
      this.remark = remark;
   }

   public Integer getMustInput() {
      return this.mustInput;
   }

   public void setMustInput(Integer mustInput) {
      this.mustInput = mustInput;
   }

   public String getDefaultValue() {
      return this.defaultValue;
   }

   public void setDefaultValue(String defaultValue) {
      this.defaultValue = defaultValue;
   }

   public String getDataFormat() {
      return this.dataFormat;
   }

   public void setDataFormat(String dataFormat) {
      this.dataFormat = dataFormat;
   }

   public String getFieldTag() {
      return this.fieldTag;
   }

   public void setFieldTag(String fieldTag) {
      this.fieldTag = fieldTag;
   }

   public Integer getDisplayListing() {
      return this.displayListing;
   }

   public void setDisplayListing(Integer displayListing) {
      this.displayListing = displayListing;
   }

   public Integer getTableType() {
      return this.tableType;
   }

   public void setTableType(Integer tableType) {
      this.tableType = tableType;
   }

   public String getTableName() {
      return this.tableName;
   }

   public void setTableName(String tableName) {
      this.tableName = tableName;
   }

   public Integer getMaxLength() {
      return this.maxLength;
   }

   public void setMaxLength(Integer maxLength) {
      this.maxLength = maxLength;
   }

   public Integer getSearchField() {
      return this.searchField;
   }

   public void setSearchField(Integer searchField) {
      this.searchField = searchField;
   }

   public Integer getSequence() {
      return this.sequence;
   }

   public void setSequence(Integer sequence) {
      this.sequence = sequence;
   }

   public Integer getStatus() {
      return this.status;
   }

   public void setStatus(Integer status) {
      this.status = status;
   }

   public Date getCreatedDate() {
      return this.createdDate;
   }

   public void setCreatedDate(Date createdDate) {
      this.createdDate = createdDate;
   }

   public String getIsOld() {
      return this.isOld;
   }

   public void setIsOld(String isOld) {
      this.isOld = isOld;
   }

   public Integer getReadOnly() {
      return this.readOnly;
   }

   public void setReadOnly(Integer readOnly) {
      this.readOnly = readOnly;
   }

   public String getFormId() {
      return this.formId;
   }

   public void setFormId(String formId) {
      this.formId = formId;
   }

   public String getMetaId() {
      return this.metaId;
   }

   public void setMetaId(String metaId) {
      this.metaId = metaId;
   }

   public String getAttrName() {
      return this.attrName;
   }

   public void setAttrName(String attrName) {
      this.attrName = attrName;
   }

   public String getDataSourceType() {
      return this.dataSourceType;
   }

   public void setDataSourceType(String dataSourceType) {
      this.dataSourceType = dataSourceType;
   }

   public String getDataSource() {
      return this.dataSource;
   }

   public void setDataSource(String dataSource) {
      this.dataSource = dataSource;
   }

   public String getCssStyle() {
      return this.cssStyle;
   }

   public void setCssStyle(String cssStyle) {
      this.cssStyle = cssStyle;
   }

   public String getCheckFunction() {
      return this.checkFunction;
   }

   public void setCheckFunction(String checkFunction) {
      this.checkFunction = checkFunction;
   }

   public String getJsFunction() {
      return this.jsFunction;
   }

   public void setJsFunction(String jsFunction) {
      this.jsFunction = jsFunction;
   }
}
