package com.huigou.uasp.form.domain.model;

import com.huigou.data.domain.model.AbstractEntity;
import com.huigou.uasp.form.model.ueform.field.FormField;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

@Entity
@Table(
   name = "saf_form_list"
)
public class SafFormslist extends AbstractEntity {
   private static final long serialVersionUID = 1L;
   @Column(
      name = "form_no",
      length = 100
   )
   private String formNo;
   @Column(
      name = "form_name",
      length = 100
   )
   private String formName;
   @Column(
      name = "package_name",
      length = 100
   )
   private String packageName;
   @Column(
      name = "form_path",
      length = 100
   )
   private String formPath;
   @Column(
      name = "save_mode",
      length = 64
   )
   private String saveMode;
   @Column(
      name = "json",
      length = 100000
   )
   private String json;
   @Transient
   public List<FormAttribute> formAttributeList;
   @Transient
   public List<FormSearchSql> formSearchSqlList;
   @Column(
      name = "pagedatail_cols",
      length = 22
   )
   private Integer pagedatailCols;
   @Column(
      name = "label_cols",
      length = 22
   )
   private Integer labelCols;
   @Column(
      name = "field_cols",
      length = 22
   )
   private Integer fieldCols;
   @Column(
      name = "textarea_rows",
      length = 22
   )
   private Integer textareaRows;
   @Column(
      name = "exist_attachment",
      length = 22
   )
   private Integer existAttachment;

   public String getFormNo() {
      return this.formNo;
   }

   public void setFormNo(String formNo) {
      this.formNo = formNo;
   }

   public String getFormName() {
      return this.formName;
   }

   public void setFormName(String formName) {
      this.formName = formName;
   }

   public String getPackageName() {
      return this.packageName;
   }

   public void setPackageName(String packageName) {
      this.packageName = packageName;
   }

   public String getFormPath() {
      return this.formPath;
   }

   public void setFormPath(String formPath) {
      this.formPath = formPath;
   }

   public String getSaveMode() {
      return this.saveMode;
   }

   public void setSaveMode(String saveMode) {
      this.saveMode = saveMode;
   }

   public String getJson() {
      return this.json;
   }

   public void setJson(String json) {
      this.json = json;
   }

   public List<FormAttribute> getFormAttributeList() {
      return this.formAttributeList;
   }

   public void setFormAttributeList(List<FormAttribute> formAttributeList) {
      this.formAttributeList = formAttributeList;
   }

   public List<FormSearchSql> getFormSearchSqlList() {
      return this.formSearchSqlList;
   }

   public void setFormSearchSqlList(List<FormSearchSql> formSearchSqlList) {
      this.formSearchSqlList = formSearchSqlList;
   }

   public Integer getPagedatailCols() {
      return this.pagedatailCols;
   }

   public void setPagedatailCols(Integer pagedatailCols) {
      this.pagedatailCols = pagedatailCols;
   }

   public Integer getLabelCols() {
      return this.labelCols;
   }

   public void setLabelCols(Integer labelCols) {
      this.labelCols = labelCols;
   }

   public Integer getFieldCols() {
      return this.fieldCols;
   }

   public void setFieldCols(Integer fieldCols) {
      this.fieldCols = fieldCols;
   }

   public Integer getTextareaRows() {
      return this.textareaRows;
   }

   public void setTextareaRows(Integer textareaRows) {
      this.textareaRows = textareaRows;
   }

   public Integer getExistAttachment() {
      return this.existAttachment;
   }

   public void setExistAttachment(Integer existAttachment) {
      this.existAttachment = existAttachment;
   }

   public static List assembleData(List<String> list, FormField formfield) {
      list.add(formfield.getName());
      return list;
   }

   public static String listToString(List<String> list, String separator) {
      StringBuilder sb = new StringBuilder();

      for(int i = 0; i < list.size(); ++i) {
         sb.append((String)list.get(i));
         if (i < list.size() - 1) {
            sb.append(separator);
         }
      }

      return sb.toString();
   }
}
