package com.huigou.uasp.form.model.ueform.field;

import com.alibaba.fastjson.JSON;
import com.huigou.uasp.util.Utils;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Checkboxs extends FormField {
   private List<CheckboxOption> options;
   private String value_type;
   private String url;
   private String url_title_field;
   private String url_value_field;

   public List<CheckboxOption> getOptions() {
      return this.options;
   }

   public void setOptions(List<CheckboxOption> options) {
      this.options = options;
   }

   public String getValue_type() {
      return this.value_type;
   }

   public void setValue_type(String value_type) {
      this.value_type = value_type;
   }

   public String getUrl() {
      return this.url;
   }

   public void setUrl(String url) {
      this.url = url;
   }

   public String getUrl_title_field() {
      return this.url_title_field;
   }

   public void setUrl_title_field(String url_title_field) {
      this.url_title_field = url_title_field;
   }

   public String getUrl_value_field() {
      return this.url_value_field;
   }

   public void setUrl_value_field(String url_value_field) {
      this.url_value_field = url_value_field;
   }

   public static Checkboxs parseText(String text) {
      Checkboxs checkbox = new Checkboxs();
      String checkbox_regex = "<span([^<>]*?)>";
      String[] sts = Utils.maches(text, checkbox_regex);
      if (sts != null && sts.length > 0) {
         checkbox = (Checkboxs)Utils.parseInputAttrsT(sts[0], Checkboxs.class);
      }

      String option_regex = "<input([^<>]*?)/>";
      String[] ts = Utils.maches(text, option_regex);
      List<CheckboxOption> os = new ArrayList();
      String[] var10 = ts;
      int var9 = ts.length;

      for(int var8 = 0; var8 < var9; ++var8) {
         String t = var10[var8];
         CheckboxOption option = (CheckboxOption)Utils.parseInputAttrsT(t, CheckboxOption.class);
         option.setTitle(option.getValue());
         option.setContent(t);
         os.add(option);
      }

      checkbox.setOptions(os);
      return checkbox;
   }

   public String getView(String value) {
      return this.parseHtml(value, true);
   }

   private String parseHtml(String value, boolean readonly) {
      String template = this.getContent();
      List<CheckboxOption> os = this.getOptions();
      String js;
      if (this.value_type != null && this.value_type.equals("url")) {
         Iterator var10 = os.iterator();

         while(var10.hasNext()) {
            CheckboxOption o = (CheckboxOption)var10.next();
            if (o.getTest() != null && o.getTest().equals("1")) {
               template = template.replace(o.getContent(), "");
            }
         }

         template = template.replace("CHECKBOXS_URL&nbsp;", "");
         String url = this.getUrl();
         String field_value_name = this.getUrl_value_field();
         String field_title_name = this.getUrl_title_field();
         js = "<script>";
         js = js + "$(function(){  $.ajax({  type: 'GET', url : '" + url + "' , " + " success : function(data){" + " if(data && data.length > 0){" + " var html = '' ;" + " var _vals = " + (value != null && value.length() > 0 && !value.equals("[]") ? value : "[]") + " ;" + " for(var i in data) {";
         if (field_value_name != null && !field_value_name.trim().equals("null")) {
            js = js + " var v = data[i][\"" + field_value_name + "\"] , t=data[i][\"" + field_title_name + "\"]; ";
         } else {
            js = js + " var v = data[i],t=data[i]; ";
         }

         js = js + " \thtml += '<input  type=\"checkbox\" name=\"" + this.getName() + "\" value=\"' + v + '\" ' ;";
         if (value != null && value.length() > 0 && !value.equals("[]")) {
            js = js + " for(var j in _vals){ ";
            js = js + " if(v == _vals[j] ) {";
            js = js + " html += ' checked=\"checked\" ' ; ";
            js = js + " break ;}";
            js = js + " } ";
         }

         if (readonly) {
            js = js + " html += ' disabled=\"disabled\" ' ;";
         }

         js = js + " html += '/>' + t + '&nbsp;' ; } $('[name=\"" + this.getName() + "\"]').html(html); " + " }" + " }" + " });" + " });";
         js = js + "</script>";
         return template + js;
      } else {
         List<String> jsonValues = null;
         if (value != null && value.trim().length() > 1) {
            jsonValues = JSON.parseArray(value, String.class);
         }

         CheckboxOption o;
         for(Iterator var7 = os.iterator(); var7.hasNext(); template = template.replace(o.getContent(), js)) {
            o = (CheckboxOption)var7.next();
            js = o.getParse(jsonValues, readonly);
         }

         return template;
      }
   }

   public String getEdit(String value) {
      return this.parseHtml(value, false);
   }
}
