package com.huigou.uasp.form.model.ueform.field;

import com.alibaba.fastjson.JSONObject;
import com.huigou.uasp.util.Utils;

public class FormField {
   private String leipiplugins;
   private String type;
   private String title;
   private String content;
   private String notnull;
   private String orgwidth;
   private String style;
   private String name;
   private String value;

   public String getLeipiplugins() {
      return this.leipiplugins;
   }

   public void setLeipiplugins(String leipiplugins) {
      this.leipiplugins = leipiplugins;
   }

   public String getType() {
      return this.type;
   }

   public void setType(String type) {
      this.type = type;
   }

   public String getTitle() {
      return this.title;
   }

   public void setTitle(String title) {
      this.title = title;
   }

   public String getContent() {
      return this.content;
   }

   public void setContent(String content) {
      this.content = content;
   }

   public String getNotnull() {
      return this.notnull;
   }

   public void setNotnull(String notnull) {
      this.notnull = notnull;
   }

   public String getOrgwidth() {
      return this.orgwidth;
   }

   public void setOrgwidth(String orgwidth) {
      this.orgwidth = orgwidth;
   }

   public String getStyle() {
      return this.style == null ? "" : this.style;
   }

   public void setStyle(String style) {
      this.style = style;
   }

   public String getName() {
      return this.name;
   }

   public void setName(String name) {
      this.name = name;
   }

   public String getValue() {
      return this.value;
   }

   public void setValue(String value) {
      this.value = value;
   }

   public String getView(String value) {
      if (value == null) {
         value = "";
      }

      return value;
   }

   public String getEdit(String value) {
      if (value == null) {
         value = "";
      }

      String val_str = "value=\"" + value + "\"";
      String str = this.getContent().replaceFirst("value=\"([^\"]*?)\"", val_str);
      return str;
   }

   public static FormField parseText(String text) {
      text = text.replace("|-", "").replace("-|", "");
      JSONObject attrs = Utils.parseInputAttrs(text);
      String tag = attrs.getString("leipiplugins");
      FormField ff = null;
      if (tag.equals("text")) {
         ff = Text.parseText(text);
      } else if (tag.equals("textarea")) {
         ff = TextArea.parseText(text);
      } else if (tag.equals("select")) {
         ff = Select.parseText(text);
      } else if (tag.equals("radios")) {
         ff = Radios.parseText(text);
      } else if (tag.equals("checkboxs")) {
         ff = Checkboxs.parseText(text);
      } else if (tag.equals("listctrl")) {
         ff = ListCtrl.parseText(text);
      } else if (tag.equals("datepicker")) {
         ff = DatePicker.parseText(text);
      }

      if (ff != null) {
         ((FormField)ff).setContent(text);
      }

      return (FormField)ff;
   }
}
