package com.huigou.uasp.form.model.ueform.field;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huigou.uasp.util.Utils;
import java.util.Iterator;
import java.util.Set;

public class ListCtrl extends FormField {
   private String orgtitle;
   private String orgcoltype;
   private String orgunit;
   private String orgsum;
   private String orgcolvalue;
   private String orgkey;

   public String getOrgtitle() {
      return this.orgtitle;
   }

   public void setOrgtitle(String orgtitle) {
      this.orgtitle = orgtitle;
   }

   public String getOrgcoltype() {
      return this.orgcoltype;
   }

   public void setOrgcoltype(String orgcoltype) {
      this.orgcoltype = orgcoltype;
   }

   public String getOrgunit() {
      return this.orgunit;
   }

   public void setOrgunit(String orgunit) {
      this.orgunit = orgunit;
   }

   public String getOrgsum() {
      return this.orgsum;
   }

   public void setOrgsum(String orgsum) {
      this.orgsum = orgsum;
   }

   public String getOrgcolvalue() {
      return this.orgcolvalue;
   }

   public void setOrgcolvalue(String orgcolvalue) {
      this.orgcolvalue = orgcolvalue;
   }

   public String getOrgkey() {
      return this.orgkey;
   }

   public void setOrgkey(String orgkey) {
      this.orgkey = orgkey;
   }

   public static ListCtrl parseText(String text) {
      ListCtrl t = (ListCtrl)Utils.parseInputAttrsT(text, ListCtrl.class);
      return t;
   }

   public String getView(String value) {
      JSONObject jsonValue = null;

      try {
         if (value != null && value.trim().length() > 1) {
            jsonValue = JSON.parseObject(value);
         }
      } catch (Exception var4) {
         System.out.println(var4);
         jsonValue = null;
      }

      return this.parseListCtrl(this, 2, jsonValue);
   }

   public String getEdit(String value) {
      JSONObject jsonValue = null;

      try {
         if (value != null && value.trim().length() > 1) {
            jsonValue = JSON.parseObject(value);
         }
      } catch (Exception var4) {
         System.out.println(var4);
         jsonValue = null;
      }

      return this.parseListCtrl(this, 1, jsonValue);
   }

   private String parseListCtrl(ListCtrl lc, int type, JSONObject listCtrlValue) {
      String name = lc.getName();
      String temp_html = type != 1 ? "" : "<script>  function tbAddRow(dname)   {  var sTbid = dname+'_table'; var size = parseInt($('#' + dname + '_length').val());   var fields = $('#' + dname + '_field').val();   var fs =  fields.split('`');   var table = '<tr>' ;  for(var i = 0 ; i < fs.length ; i++) {\t if(fs[i] && fs[i] != '') {\t\t table += '<td><input class=\"input-medium\" type=\"text\" name=' + dname + '[' + (size+1) + '][' + fs[i] + ']  value=\"\"> </td>'; }}    \t\t table += '<td><a href=\"javascript:void(0);\" onclick=\"fnDeleteRow(this)\" class=\"delrow show\">删除</a></td>';   table += '</tr>';  $('#' + dname + '_length').val(size+1);  $('#'+sTbid).append(table);  } function fnDeleteRow(obj) {   var sTbid = '" + name + "_table';" + "   var oTable = document.getElementById(sTbid);" + "   while(obj.tagName !='TR')" + "  {" + "       obj = obj.parentNode;" + "  }" + "  oTable.deleteRow(obj.rowIndex);" + "  var size = $('#" + name + "_length').val(); " + "  $('#" + name + "_length').val(size - 1);  " + " }" + "</script>";
      String[] fields = lc.getOrgtitle().split("`");
      String[] filed_keys = lc.getOrgkey().split("`");
      String table = "<table id=\"" + name + "_table\" cellspacing=\"0\" class=\"table table-bordered table-condensed\" style=\"width: 100%;\"><thead>";
      table = table + " <tr><th colspan=\"" + fields.length + "\">" + this.getTitle();
      if (type == 1) {
         table = table + "<span class=\"pull-right\"> <button class=\"btn btn-small btn-success\" type=\"button\" onclick=\"tbAddRow('" + name + "')\">添加一行</button>" + "</span> ";
      }

      table = table + "</th></tr><tr>";

      int i;
      for(i = 0; i < fields.length; ++i) {
         if (fields[i] != null && fields[i].length() > 0) {
            table = table + "<th>" + fields[i] + "</th>";
         }
      }

      table = table + "</tr></thead>";
      Set keys;
      if (type == 2) {
         if (listCtrlValue != null) {
            keys = listCtrlValue.keySet();

            for(Iterator var11 = keys.iterator(); var11.hasNext(); table = table + " </tr>") {
               String key = (String)var11.next();
               JSONObject _key_v = listCtrlValue.getJSONObject(key);
               table = table + " <tr class=\"template\">";

               for(int j = 0; j < fields.length && j < filed_keys.length && j < _key_v.size(); ++j) {
                  if (fields[j] != null && fields[j].length() > 0) {
                     table = table + "<td>" + _key_v.getString(filed_keys[j]) + "</td>";
                  }
               }
            }
         }
      } else {
         table = table + " <tr class=\"template\">";
         if (listCtrlValue != null) {
            keys = listCtrlValue.keySet();
            int index = 0;

            for(Iterator var19 = keys.iterator(); var19.hasNext(); ++index) {
               String key = (String)var19.next();
               JSONObject _key_v = listCtrlValue.getJSONObject(key);
               table = table + " <tr class=\"template\">";

               for(int j = 0; j < fields.length && j < filed_keys.length && j < _key_v.size(); ++j) {
                  if (filed_keys[j] != null && filed_keys[j].length() > 0) {
                     table = table + "<td><input class=\"input-medium\" type=\"text\" name=\"" + name + "[" + index + "][" + filed_keys[j] + "]\" value=\"" + _key_v.getString(filed_keys[j]) + "\"> </td>";
                  }
               }

               table = table + "<td><a href=\"javascript:void(0);\" onclick=\"fnDeleteRow(this)\" class=\"delrow show\">删除</a></td>";
               table = table + " </tr>";
            }
         } else {
            for(i = 0; i < fields.length && i < filed_keys.length; ++i) {
               if (filed_keys[i] != null && filed_keys[i].length() > 0) {
                  table = table + "<td><input class=\"input-medium\" type=\"text\" name=\"" + name + "[0][" + filed_keys[i] + "]\" value=\"\"> </td>";
               }
            }

            table = table + "<td><a href=\"javascript:void(0);\" onclick=\"fnDeleteRow(this)\" class=\"delrow hide\">删除</a></td>";
            table = table + " </tr>";
         }

         i = listCtrlValue != null ? listCtrlValue.size() : 0;
         table = table + "<input type=\"hidden\" id='" + name + "_length' value='" + i + "' >";
         table = table + "<input type=\"hidden\" id='" + name + "_field' value='" + lc.getOrgkey() + "' >";
      }

      table = table + " </tbody> </table>";
      String content = temp_html + "<p>" + table + "</p>";
      return content;
   }
}
