package com.huigou.uasp.form.model.ueform.field;

import com.huigou.uasp.util.Utils;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Radios extends FormField {
   private List<RadioOption> options;
   private String value_type;
   private String url;
   private String url_title_field;
   private String url_value_field;

   public List<RadioOption> getOptions() {
      return this.options;
   }

   public void setOptions(List<RadioOption> options) {
      this.options = options;
   }

   public String getValue_type() {
      return this.value_type;
   }

   public void setValue_type(String value_type) {
      this.value_type = value_type;
   }

   public String getUrl() {
      return this.url;
   }

   public void setUrl(String url) {
      this.url = url;
   }

   public String getUrl_title_field() {
      return this.url_title_field;
   }

   public void setUrl_title_field(String url_title_field) {
      this.url_title_field = url_title_field;
   }

   public String getUrl_value_field() {
      return this.url_value_field;
   }

   public void setUrl_value_field(String url_value_field) {
      this.url_value_field = url_value_field;
   }

   public static Radios parseText(String text) {
      Radios radio = new Radios();
      String radio_regex = "<span([^<>]*?)>";
      String[] sts = Utils.maches(text, radio_regex);
      if (sts != null && sts.length > 0) {
         radio = (Radios)Utils.parseInputAttrsT(sts[0], Radios.class);
      }

      String option_regex = "<input([^<>]*?)/>";
      String[] ts = Utils.maches(text, option_regex);
      List<RadioOption> os = new ArrayList();
      String[] var10 = ts;
      int var9 = ts.length;

      for(int var8 = 0; var8 < var9; ++var8) {
         String t = var10[var8];
         RadioOption option = (RadioOption)Utils.parseInputAttrsT(t, RadioOption.class);
         option.setTitle(option.getValue());
         option.setContent(t);
         os.add(option);
      }

      radio.setOptions(os);
      return radio;
   }

   public String getView(String value) {
      return this.parseHtml(value, true);
   }

   private String parseHtml(String value, boolean disabled) {
      String template = this.getContent();
      List<RadioOption> os = this.getOptions();
      RadioOption o;
      Iterator var6;
      String field_title_name;
      if (this.value_type != null && this.value_type.equals("url")) {
         var6 = os.iterator();

         while(var6.hasNext()) {
            o = (RadioOption)var6.next();
            if (o.getTest() != null && o.getTest().equals("1")) {
               template = template.replace(o.getContent(), "");
            }
         }

         template = template.replace("RADIO_URL&nbsp;", "");
         String url = this.getUrl();
         String field_value_name = this.getUrl_value_field();
         field_title_name = this.getUrl_title_field();
         String js = "<script>";
         js = js + "$(function(){  $.ajax({  type: 'GET', url : '" + url + "' , " + " success : function(data){" + " if(data && data.length > 0){" + " var html = '' ;" + " for(var i in data) {";
         if (field_value_name != null && !field_value_name.trim().equals("null")) {
            js = js + " var v = data[i][\"" + field_value_name + "\"] , t=data[i][\"" + field_title_name + "\"]; ";
         } else {
            js = js + " var v = data[i],t=data[i]; ";
         }

         js = js + " \thtml += '<input  type=\"radio\" name=\"" + this.getName() + "\" value=\"' + v + '\" ' ;";
         if (value != null && value.length() > 0) {
            js = js + " if(v == '" + value + "' || data.length == 1){ ";
            js = js + " html += ' checked=\"checked\" ' ; ";
            js = js + " } ";
         } else {
            js = js + " if(data.length == 1){ ";
            js = js + " html += ' checked=\"checked\" ' ; ";
            js = js + " } ";
         }

         if (disabled) {
            js = js + " html += ' disabled=\"disabled\"' ;";
         }

         js = js + " html += '/>' + t + '&nbsp;' ; } $('[name=\"" + this.getName() + "\"]').html(html); " + " }" + " }" + " });" + " });";
         js = js + "</script>";
         return template + js;
      } else {
         for(var6 = os.iterator(); var6.hasNext(); template = template.replace(o.getContent(), field_title_name)) {
            o = (RadioOption)var6.next();
            field_title_name = o.getParse(o.getValue().equals(value), disabled);
         }

         return template;
      }
   }

   public String getEdit(String value) {
      return this.parseHtml(value, false);
   }
}
