package com.huigou.uasp.form.model.ueform.field;

import com.huigou.uasp.util.Utils;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Select extends FormField {
   private int size;
   private String value_type;
   private String url;
   private String url_title_field;
   private String url_value_field;
   private List<SelectOption> options;

   public int getSize() {
      return this.size;
   }

   public void setSize(int size) {
      this.size = size;
   }

   public List<SelectOption> getOptions() {
      return this.options;
   }

   public void setOptions(List<SelectOption> options) {
      this.options = options;
   }

   public String getValue_type() {
      return this.value_type;
   }

   public void setValue_type(String value_type) {
      this.value_type = value_type;
   }

   public String getUrl() {
      return this.url;
   }

   public void setUrl(String url) {
      this.url = url;
   }

   public String getUrl_title_field() {
      return this.url_title_field;
   }

   public void setUrl_title_field(String url_title_field) {
      this.url_title_field = url_title_field;
   }

   public String getUrl_value_field() {
      return this.url_value_field;
   }

   public void setUrl_value_field(String url_value_field) {
      this.url_value_field = url_value_field;
   }

   public static Select parseText(String text) {
      Select select = new Select();
      String select_regex = "<select([^<>]*?)>";
      String[] sts = Utils.maches(text, select_regex);
      if (sts != null && sts.length > 0) {
         select = (Select)Utils.parseInputAttrsT(sts[0], Select.class);
      }

      String option_regex = "<option([^<>]*?)>(.*?)</option>";
      String[] ts = Utils.maches(text, option_regex);
      List<SelectOption> os = new ArrayList();
      String[] var10 = ts;
      int var9 = ts.length;

      for(int var8 = 0; var8 < var9; ++var8) {
         String t = var10[var8];
         SelectOption option = (SelectOption)Utils.parseInputAttrsT(t, SelectOption.class);
         option.setTitle(option.getValue());
         option.setContent(t);
         os.add(option);
      }

      select.setOptions(os);
      return select;
   }

   public String getView(String value) {
      if (value != null && value.trim().length() >= 1) {
         if (value != null && this.value_type != null && this.value_type.equals("url")) {
            String url = this.getUrl();
            String field_value_name = this.getUrl_value_field();
            String field_title_name = this.getUrl_title_field();
            String js = "<script>";
            js = js + "$(function(){  $.ajax({  type: 'GET', url : '" + url + "' , " + " success : function(data){" + " if(data && data.length > 0){" + " var html = '' ;" + " var _s_title = '';  " + " for(var i in data) {";
            if (field_value_name != null && !field_value_name.trim().equals("null")) {
               js = js + " var v = data[i][\"" + field_value_name + "\"] , t=data[i][\"" + field_title_name + "\"]; ";
            } else {
               js = js + " var v = data[i],t=data[i]; ";
            }

            js = js + " if(v == '" + value + "'){ ";
            js = js + "  _s_title = t; ";
            js = js + "  break; ";
            js = js + " } ";
            js = js + " } $('[name=\"" + this.getName() + "\"]').html(_s_title); " + " }" + " }" + " });" + " });";
            js = js + "</script>";
            return "<span name=\"" + this.getName() + "\">" + js + "</span>";
         }
      } else {
         List<SelectOption> os = this.getOptions();
         if (os != null && this.value_type != null && this.value_type.equals("mine")) {
            Iterator var4 = os.iterator();

            while(var4.hasNext()) {
               SelectOption o = (SelectOption)var4.next();
               if (o.getSelected() != null && o.getSelected().trim().length() > 0) {
                  value = o.getValue();
                  break;
               }
            }
         }
      }

      return super.getView(value);
   }

   public String getEdit(String value) {
      String template = this.getContent();
      if (value != null && value.trim().length() >= 1 || this.value_type != null && !this.value_type.equals("mine")) {
         List<SelectOption> os = this.getOptions();
         SelectOption o;
         String field_title_name;
         if (os != null && this.value_type != null && this.value_type.equals("mine")) {
            for(Iterator var5 = os.iterator(); var5.hasNext(); template = template.replace(o.getContent(), field_title_name)) {
               o = (SelectOption)var5.next();
               field_title_name = o.getParse(o.getValue().equals(value));
            }
         }

         if (this.value_type != null && this.value_type.equals("url")) {
            String url = this.getUrl();
            String field_value_name = this.getUrl_value_field();
            field_title_name = this.getUrl_title_field();
            String js = "<script>";
            js = js + "$(function(){  $.ajax({  type: 'GET', url : '" + url + "' , " + " success : function(data){" + " if(data && data.length > 0){" + " var html = '' ;" + " for(var i in data) {";
            if (field_value_name != null && !field_value_name.trim().equals("null")) {
               js = js + " var v = data[i][\"" + field_value_name + "\"] , t=data[i][\"" + field_title_name + "\"]; ";
            } else {
               js = js + " var v = data[i],t=data[i]; ";
            }

            js = js + " \thtml += '<option value=\"' + v + '\" ' ;";
            if (value != null && value.length() > 0) {
               js = js + " if(v == '" + value + "'){ ";
               js = js + " html += 'selected=\"selected\" ' ; ";
               js = js + " } ";
            }

            js = js + " html += '>' + t + '</option>'; } $('[name=\"" + this.getName() + "\"]').html(html); " + " }" + " }" + " });" + " });";
            js = js + "</script>";
            template = template + js;
         }

         return template;
      } else {
         return template;
      }
   }
}
