package com.huigou.uasp.form.repository;

import com.huigou.uasp.form.domain.model.FormAttribute;
import java.util.List;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

public interface FormAttributeRepository extends JpaRepository<FormAttribute, String> {
   List<FormAttribute> findByFormId(String var1);

   @Query("from FormAttribute s where  s.formId=?1 and s.tableName=?2 ")
   List<FormAttribute> findByFormIdAndTable(String var1, String var2);

   @Query("from FormAttribute s where  s.formId=?1 and s.tableType=?2 ")
   List<FormAttribute> findByFormIdAndType(String var1, int var2);

   @Modifying
   @Query("delete from FormAttribute u WHERE u.formId=?1 ")
   void deleteFormAttribute(String var1);

   @Modifying
   @Query("delete from FormAttribute u WHERE u.formId=?1 and u.tableName=?2 ")
   void deleteFormAttributeByFormIdAndTableName(String var1, String var2);

   @Modifying
   @Query("UPDATE FormAttribute u SET u.displayListing = ?1 WHERE u.formId = ?2")
   void updateDisplayListing(Integer var1, String var2);

   @Modifying
   @Query("UPDATE FormAttribute u SET u.searchField = ?1 WHERE u.formId = ?2")
   void updateSearchField(Integer var1, String var2);
}
