package com.huigou.uasp.form.repository;

import com.huigou.uasp.form.domain.model.FormSearchSql;
import java.util.List;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

public interface FormSearchSqlRepository extends JpaRepository<FormSearchSql, String> {
   List<FormSearchSql> findById(String var1);

   @Query("from FormSearchSql s where  s.formNo=?1 and s.targetField=?2 ")
   List<FormSearchSql> searchSqlByFormNoAndField(String var1, String var2);

   @Query("from FormSearchSql s where  s.formNo=?1 ")
   List<FormSearchSql> searchSqlByFormNo(String var1);

   @Query("from FormSearchSql s where  s.formNo=?1 and s.searchName=?2 ")
   List<FormSearchSql> searchSqlByFormNoAndSearchName(String var1, String var2);

   @Modifying
   @Query("delete from FormSearchSql u WHERE u.tableName=?1 and u.targetField=?2 ")
   void deleteSearchSqlByTableField(String var1, String var2);
}
