package com.huigou.uasp.meta.controller;

import com.huigou.cache.SystemCache;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.bmp.configuration.domain.model.SysDictionary;
import com.huigou.uasp.client.CommonController;
import com.huigou.uasp.meta.application.MetaDataApplication;
import com.huigou.uasp.meta.domain.model.BusinessType;
import com.huigou.uasp.meta.domain.model.MetaData;
import com.huigou.uasp.meta.domain.model.MetaDataDICT;
import com.huigou.uasp.meta.domain.query.MetaDataQueryRequest;
import com.huigou.uasp.meta.repository.BusinessTypeRepository;
import com.huigou.uasp.meta.repository.MetaDataDICTRepository;
import com.huigou.uasp.meta.repository.MetaDataRepository;
import com.huigou.uasp.meta.repository.QueryCodeBuildRuleRepository;
import com.huigou.util.ClassHelper;
import com.huigou.util.SDO;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.Assert;
import org.springframework.util.StringUtils;

@Controller
@ControllerMapping({"metaData"})
public class MetaDataController extends CommonController {
   @Autowired
   private MetaDataRepository mdmMetaDataRepository;
   @Autowired
   private MetaDataApplication mdmMetaDataApplication;
   @Autowired
   private BusinessTypeRepository mdmBusinessTypeRepository;
   @Autowired
   private MetaDataDICTRepository mdmMetaDataDICTRepository;
   @Autowired
   private QueryCodeBuildRuleRepository queryCodeBuildRuleRepository;

   protected String getPagePath() {
      return "/formdesign/meta/";
   }

   public String forwardMdmMetaDataList() {
      return this.forward("mdmMetaDataList");
   }

   public String forwardMdmBusinessTypeList() {
      return this.forward("mdmBusinessTypeList");
   }

   public String slicedQueryMdmMetaData() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      String fullId = sdo.getString("fullId");
      MetaDataQueryRequest queryRequest = (MetaDataQueryRequest)sdo.toQueryRequest(MetaDataQueryRequest.class);
      List<BusinessType> mdmBusinessType = this.mdmBusinessTypeRepository.findByFullId(fullId);
      List<String> ids = new ArrayList(mdmBusinessType.size());
      Iterator var9 = mdmBusinessType.iterator();

      while(var9.hasNext()) {
         BusinessType type = (BusinessType)var9.next();
         ids.add(type.getId());
      }

      if (ids.size() <= 0) {
         Map<String, Object> data = this.mdmMetaDataApplication.queryMdmMetaData(queryRequest);
         return this.toResult(data);
      } else {
         List<MetaData> byClassifyIdIn = this.mdmMetaDataRepository.findByClassifyIdIn(ids);
         List<String> mdmMetaDataIds = new ArrayList(byClassifyIdIn.size());
         Iterator var11 = byClassifyIdIn.iterator();

         while(var11.hasNext()) {
            MetaData m = (MetaData)var11.next();
            mdmMetaDataIds.add(m.getId());
         }

         queryRequest.setId(String.join(",", mdmMetaDataIds));
         Map<String, Object> Map1 = this.mdmMetaDataApplication.queryMdmMetaDataDICT(queryRequest);
         return this.toResult(Map1);
      }
   }

   public String loadMdmMetaDataDetail() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      MetaData mdmMetaData = new MetaData();
      mdmMetaData.setClassifyId(id);
      return this.forward("mdmMetaDataDetail", mdmMetaData);
   }

   public String loadMdmMetaDataCopy() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      BusinessType mdmBusinessType = (BusinessType)this.mdmBusinessTypeRepository.findOne(id);
      return this.forward("mdmMetaDataCopy", mdmBusinessType);
   }

   public String slicedQueryOldMdmMetaData() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      MetaDataQueryRequest queryRequest = (MetaDataQueryRequest)sdo.toQueryRequest(MetaDataQueryRequest.class);
      List<MetaData> mdmMetaData = this.mdmMetaDataRepository.findByClassifyId(id);
      return this.packGridDataAndResult(mdmMetaData);
   }

   public String slicedQueryNewMdmMetaData() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      String newBusinessDataName = sdo.getString("newBusinessDataName");
      MetaDataQueryRequest queryRequest = (MetaDataQueryRequest)sdo.toQueryRequest(MetaDataQueryRequest.class);
      if (StringUtils.isEmpty(newBusinessDataName)) {
         return this.success();
      } else {
         List<MetaData> mdmMetaData = this.mdmMetaDataRepository.findByClassifyId(id);
         List<Map<String, Object>> map = new ArrayList();
         Iterator var8 = mdmMetaData.iterator();

         while(var8.hasNext()) {
            MetaData metaData = (MetaData)var8.next();
            Map<String, Object> attribute = ClassHelper.beanToMap(metaData);
            attribute.put("isOld", 1);
            map.add(attribute);
         }

         String result = this.packGridDataAndResult(map);
         return result;
      }
   }

   public String updateMdmMetaData() {
      SDO sdo = this.getSDO();
      String id = sdo.getString("id");
      MetaData mdmMetaData = this.mdmMetaDataApplication.loadMdmMetaData(id);
      MetaDataDICT byMetaDataId = this.mdmMetaDataDICTRepository.findByMetaDataId(id);
      if (byMetaDataId != null) {
         this.putAttribute("dictCode", byMetaDataId.getDictCode());
      }

      return this.forward("mdmMetaDataDetail", mdmMetaData);
   }

   public String saveMdmMetaData() {
      SDO sdo = this.getSDO();
      MetaData entity = (MetaData)sdo.toObject(MetaData.class);
      MetaDataDICT mdmMetaDataDICT = (MetaDataDICT)sdo.toObject(MetaDataDICT.class);
      mdmMetaDataDICT.setClassifyId(entity.getClassifyId());
      entity.setStatus(1);
      this.mdmMetaDataRepository.save(entity);
      mdmMetaDataDICT.setMetaDataId(entity.getId());
      MetaDataDICT byMetaDataId = this.mdmMetaDataDICTRepository.findByMetaDataId(mdmMetaDataDICT.getMetaDataId());
      SysDictionary byCode = this.queryCodeBuildRuleRepository.findByCode(mdmMetaDataDICT.getDictCode());
      if (byMetaDataId != null) {
         byMetaDataId.setDictName(byCode.getName());
         byMetaDataId.setDictCode(byCode.getCode());
         this.mdmMetaDataDICTRepository.save(byMetaDataId);
      } else if (byCode != null) {
         mdmMetaDataDICT.setDictName(byCode.getName());
         this.mdmMetaDataDICTRepository.save(mdmMetaDataDICT);
      }

      return this.success();
   }

   public String saveCopyMdmMetaData() {
      SDO sdo = this.getSDO();
      String newBusinessDataId = sdo.getString("newBusinessDataId");
      List<MetaData> detailData = sdo.getList("detailData", MetaData.class);
      this.mdmMetaDataApplication.saveCopyMdmMetaData(newBusinessDataId, detailData);
      return this.success();
   }

   public String deleteMdmMetaDatas() {
      SDO sdo = this.getSDO();
      MetaDataDICT mdmMetaDataDICT = new MetaDataDICT();
      List<String> ids = sdo.getStringList("ids");
      Iterator var5 = ids.iterator();

      while(var5.hasNext()) {
         String id = (String)var5.next();
         MetaData mdmMetaData = this.mdmMetaDataApplication.loadMdmMetaData(id);
         if (mdmMetaData.getStatus() == 1) {
            Assert.isTrue(false, " 有文件处于启用状态无法删除！");
            return this.success();
         }

         mdmMetaDataDICT.setMetaDataId(id);
         MetaDataDICT byMetaDataId = this.mdmMetaDataDICTRepository.findByMetaDataId(mdmMetaDataDICT.getMetaDataId());
         if (byMetaDataId != null) {
            this.mdmMetaDataDICTRepository.delete(byMetaDataId);
         }
      }

      this.mdmMetaDataApplication.deleteMdmMetaDataByIds(ids);
      return this.success();
   }

   public String changeMdmMetaDataStatus() {
      SDO sdo = this.getSDO();
      List<String> ids = sdo.getStringList("ids");
      Integer status = sdo.getInteger("status");
      Iterator var5 = ids.iterator();

      while(var5.hasNext()) {
         String id = (String)var5.next();
         this.mdmMetaDataApplication.updateStatus(id, status);
      }

      return this.success();
   }

   public String getUserDictFolderIds() {
      String dictFolderName = (String)SystemCache.getParameter("mdmUserDictFolderName", String.class);
      Map map = new HashMap();
      String dictFolderIds = this.mdmMetaDataApplication.getMdmUserDictFolderIds(dictFolderName);
      map.put("dictFolderIds", dictFolderIds);
      return this.success(map);
   }
}
