package com.huigou.uasp.meta.domain.model;

import com.huigou.data.domain.listener.CreatorAndModifierListener;
import com.huigou.data.domain.model.AbstractEntity;
import com.huigou.data.domain.model.Creator;
import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.Table;

@Entity
@Table(
   name = "mdm_business_type"
)
@EntityListeners({CreatorAndModifierListener.class})
public class BusinessType extends AbstractEntity {
   private static final long serialVersionUID = 1L;
   @Column(
      name = "parent_id",
      length = 32
   )
   private String parentId;
   @Column(
      name = "name",
      length = 100
   )
   private String name;
   @Column(
      name = "code",
      length = 100
   )
   private String code;
   @Column(
      name = "full_id",
      length = 1000
   )
   private String fullId;
   @Column(
      name = "full_name",
      length = 1000
   )
   private String fullName;
   @Column(
      name = "remark",
      length = 1000
   )
   private String remark;
   @Column(
      name = "status",
      length = 22
   )
   private Integer status;
   @Column(
      name = "sequence",
      length = 22
   )
   private Integer sequence;
   @Column(
      name = "node_type",
      length = 22
   )
   private Integer nodeType;
   @Embedded
   private Creator creator;

   public String getParentId() {
      return this.parentId;
   }

   public void setParentId(String parentId) {
      this.parentId = parentId;
   }

   public String getName() {
      return this.name;
   }

   public void setName(String name) {
      this.name = name;
   }

   public String getCode() {
      return this.code;
   }

   public void setCode(String code) {
      this.code = code;
   }

   public String getFullId() {
      return this.fullId;
   }

   public void setFullId(String fullId) {
      this.fullId = fullId;
   }

   public String getFullName() {
      return this.fullName;
   }

   public void setFullName(String fullName) {
      this.fullName = fullName;
   }

   public String getRemark() {
      return this.remark;
   }

   public void setRemark(String remark) {
      this.remark = remark;
   }

   public Integer getStatus() {
      return this.status;
   }

   public void setStatus(Integer status) {
      this.status = status;
   }

   public Integer getSequence() {
      return this.sequence;
   }

   public void setSequence(Integer sequence) {
      this.sequence = sequence;
   }

   public Integer getNodeType() {
      return this.nodeType;
   }

   public void setNodeType(Integer nodeType) {
      this.nodeType = nodeType;
   }
}
