package com.huigou.uasp.meta.domain.model;

import com.huigou.data.domain.listener.CreatorAndModifierListener;
import com.huigou.data.domain.model.AbstractEntity;
import com.huigou.data.domain.model.Creator;
import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.Table;
import javax.persistence.Transient;

@Entity
@Table(
   name = "saf_meta_data"
)
@EntityListeners({CreatorAndModifierListener.class})
public class MetaData extends AbstractEntity {
   private static final long serialVersionUID = 1L;
   @Column(
      name = "classify_id",
      length = 32
   )
   private String classifyId;
   @Column(
      name = "field_name",
      length = 100
   )
   private String fieldName;
   @Column(
      name = "field_engname",
      length = 100
   )
   private String fieldEngname;
   @Column(
      name = "field_code",
      length = 100
   )
   private String fieldCode;
   @Column(
      name = "field_data_type",
      length = 100
   )
   private String fieldDataType;
   @Column(
      name = "field_length",
      length = 22
   )
   private Integer fieldLength;
   @Column(
      name = "field_decimal",
      length = 22
   )
   private Integer fieldDecimal;
   @Column(
      name = "field_notes",
      length = 200
   )
   private String fieldNotes;
   @Column(
      name = "code_rule_id",
      length = 32
   )
   private String codeRuleId;
   @Column(
      name = "is_null",
      length = 22
   )
   private Integer isNull;
   @Column(
      name = "is_primary_key",
      length = 10
   )
   private Integer isPrimaryKey;
   @Column(
      name = "default_value",
      length = 100
   )
   private String defaultValue;
   @Column(
      name = "remark",
      length = 1000
   )
   private String remark;
   @Column(
      name = "status",
      length = 10
   )
   private Integer status;
   @Column(
      name = "is_hidden",
      length = 10
   )
   private Integer isHidden;
   @Embedded
   private Creator creator;
   @Column(
      name = "SORT_TYPE"
   )
   private String sortType;
   @Transient
   private String sortTypeTextView;

   public String getSortTypeTextView() {
      return this.sortTypeTextView;
   }

   public void setSortTypeTextView(String sortTypeTextView) {
      this.sortTypeTextView = sortTypeTextView;
   }

   public String getSortType() {
      return this.sortType;
   }

   public void setSortType(String sortType) {
      this.sortType = sortType;
   }

   public Integer getIsPrimaryKey() {
      return this.isPrimaryKey;
   }

   public void setIsPrimaryKey(Integer isPrimaryKey) {
      this.isPrimaryKey = isPrimaryKey;
   }

   public String getDefaultValue() {
      return this.defaultValue;
   }

   public void setDefaultValue(String defaultValue) {
      this.defaultValue = defaultValue;
   }

   public String getClassifyId() {
      return this.classifyId;
   }

   public void setClassifyId(String classifyId) {
      this.classifyId = classifyId;
   }

   public String getFieldName() {
      return this.fieldName;
   }

   public void setFieldName(String fieldName) {
      this.fieldName = fieldName;
   }

   public String getFieldEngname() {
      return this.fieldEngname;
   }

   public void setFieldEngname(String fieldEngname) {
      this.fieldEngname = fieldEngname;
   }

   public String getFieldCode() {
      return this.fieldCode;
   }

   public void setFieldCode(String fieldCode) {
      this.fieldCode = fieldCode;
   }

   public String getFieldDataType() {
      return this.fieldDataType;
   }

   public void setFieldDataType(String fieldDataType) {
      this.fieldDataType = fieldDataType;
   }

   public Integer getFieldLength() {
      return this.fieldLength;
   }

   public void setFieldLength(Integer fieldLength) {
      this.fieldLength = fieldLength;
   }

   public Integer getFieldDecimal() {
      return this.fieldDecimal;
   }

   public void setFieldDecimal(Integer fieldDecimal) {
      this.fieldDecimal = fieldDecimal;
   }

   public String getFieldNotes() {
      return this.fieldNotes;
   }

   public void setFieldNotes(String fieldNotes) {
      this.fieldNotes = fieldNotes;
   }

   public String getCodeRuleId() {
      return this.codeRuleId;
   }

   public void setCodeRuleId(String codeRuleId) {
      this.codeRuleId = codeRuleId;
   }

   public Integer getIsNull() {
      return this.isNull;
   }

   public void setIsNull(Integer isNull) {
      this.isNull = isNull;
   }

   public String getRemark() {
      return this.remark;
   }

   public void setRemark(String remark) {
      this.remark = remark;
   }

   public Integer getStatus() {
      return this.status;
   }

   public void setStatus(Integer status) {
      this.status = status;
   }

   public Integer getIsHidden() {
      return this.isHidden;
   }

   public void setIsHidden(Integer isHidden) {
      this.isHidden = isHidden;
   }
}
