package com.huigou.uasp.model.application.impl;

import com.google.common.base.CaseFormat;
import com.huigou.data.repository.GeneralRepository;
import com.huigou.uasp.bmp.common.application.BaseApplication;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("dbTableService")
public class DbTableService extends BaseApplication {
    @Autowired
    private GeneralRepository generalRepository;

    public String getTableName(String modelId) {
        String tablesql = " select m.table_name tb from SAF_TABLES m where m.id='" + modelId + "'";
        List<?> talist = this.generalRepository.queryByNativeSql(tablesql, new HashMap());
        String tableName = "";
        if (talist != null && talist.size() > 0) {
            tableName = talist.get(0).toString().toLowerCase();
        }

        return tableName;
    }

    public String createTable(String tableName, String fieldCodes, String fieldTypes) {
        Connection conn = null;
        String backStr = "";

        try {
            if (tableName.length() > 30) {
                backStr = "名称太长！";
                String var14 = backStr;
                return var14;
            }

            conn = this.sqlExecutorDao.getDataSource().getConnection();
            (new StringBuilder("create table ")).append(tableName).toString();
            StringBuffer sb = new StringBuffer("");
            sb.append("create table ").append(tableName).append("(");
            String[] fieldCode = fieldCodes.split(";");
            String[] fieldType = fieldTypes.split(";");

            for (int i = 0; i < fieldCode.length; ++i) {
                sb.append(fieldCode[i]);
                sb.append(" ");
                sb.append(fieldType[i]);
                if ("id".equals(fieldCode[i])) {
                    sb.append(" not null ");
                }

                if (i < fieldCode.length - 1) {
                    sb.append(", ");
                }
            }

            sb.append(")");
            PreparedStatement ps = conn.prepareStatement(sb.toString());
            ps.execute();
            String pkId = "PK_" + tableName + "_ID";
            if (pkId.length() > 30) {
                int len = pkId.length() - 30;
                pkId = "PK_" + tableName.substring(len, tableName.length()) + "_ID";
            }

            String strSql = "alter table " + tableName + " add constraint " + pkId + "  primary key (ID)";
            ps = conn.prepareStatement(strSql);
            ps.execute();
            ps.close();
        } catch (Exception var23) {
            backStr = var23.getMessage();
            var23.printStackTrace();
        } finally {
            try {
                conn.close();
            } catch (Exception var22) {
                backStr = var22.getMessage();
                var22.printStackTrace();
            }

        }

        return backStr;
    }

    public String[] composizeFieldContent(List<Map<String, Object>> fieldList, String tableType) {
        String fieldTypes = "";
        String fieldCodes = "";
        int fieldLength = 0;
        int fieldDecimal = 0;
        String[] backStr = new String[2];
        new HashMap();

        for (int i = 0; i < fieldList.size(); ++i) {
            Map<String, Object> mapData = (Map) fieldList.get(i);
            fieldCodes = fieldCodes + mapData.get("fieldCode").toString();
            fieldLength = Integer.parseInt(mapData.get("fieldLength").toString());
            if (mapData.get("fieldDecimal") != null && !"".equals(mapData.get("fieldDecimal").toString())) {
                fieldDecimal = Integer.parseInt(mapData.get("fieldDecimal").toString());
            }

            if ("string".equals(mapData.get("fieldDataType").toString())) {
                fieldTypes = fieldTypes + "VARCHAR2(" + fieldLength + ")";
            }

            if ("number".equals(mapData.get("fieldDataType").toString())) {
                fieldTypes = fieldTypes + "NUMBER(" + fieldLength + "," + fieldDecimal + ")";
            }

            if ("date".equals(mapData.get("fieldDataType").toString())) {
                fieldTypes = fieldTypes + "DATE";
            }

            if (i < fieldList.size() - 1) {
                fieldCodes = fieldCodes + ";";
                fieldTypes = fieldTypes + ";";
            }
        }

        fieldCodes = CaseFormat.UPPER_CAMEL.to(CaseFormat.LOWER_UNDERSCORE, fieldCodes);
        if (fieldCodes.indexOf("version") < 0) {
            fieldCodes = fieldCodes + ";version";
            fieldTypes = fieldTypes + ";INTEGER";
        }

        backStr[0] = fieldCodes;
        backStr[1] = fieldTypes;
        return backStr;
    }
}
