package com.huigou.uasp.model.domain.model;

import com.huigou.data.domain.listener.CreatorAndModifierListener;
import com.huigou.data.domain.model.Creator;
import com.huigou.data.domain.model.Modifier;
import com.huigou.data.domain.model.TreeEntity;
import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.EntityListeners;
import javax.persistence.Table;

@Entity
@Table(
   name = "SAF_TABLES"
)
@EntityListeners({CreatorAndModifierListener.class})
public class DbTables extends TreeEntity {
   private static final long serialVersionUID = 1L;
   @Column(
      name = "TABLE_NAME",
      length = 128
   )
   private String tableName;
   @Column(
      name = "DESCRIPTIONS",
      length = 32
   )
   private String descriptions;
   @Column(
      name = "PRIMARY_KEY",
      length = 128
   )
   private String primartKey;
   @Column(
      name = "TITLE",
      length = 128
   )
   private String title;
   @Column(
      name = "TABLE_TYPE"
   )
   private String tableType;
   @Column(
      name = "TYPE",
      length = 32
   )
   private String type;
   @Column(
      name = "PUBLISHED",
      length = 10
   )
   private Integer published;
   @Embedded
   private Creator creator;
   @Embedded
   private Modifier modifier;

   public String getTableName() {
      return this.tableName;
   }

   public void setTableName(String tableName) {
      this.tableName = tableName;
   }

   public String getDescriptions() {
      return this.descriptions;
   }

   public void setDescriptions(String descriptions) {
      this.descriptions = descriptions;
   }

   public String getPrimartKey() {
      return this.primartKey;
   }

   public void setPrimartKey(String primartKey) {
      this.primartKey = primartKey;
   }

   public String getTitle() {
      return this.title;
   }

   public void setTitle(String title) {
      this.title = title;
   }

   public String getTableType() {
      return this.tableType;
   }

   public void setTableType(String tableType) {
      this.tableType = tableType;
   }

   public String getType() {
      return this.type;
   }

   public void setType(String type) {
      this.type = type;
   }

   public Creator getCreator() {
      return this.creator;
   }

   public void setCreator(Creator creator) {
      this.creator = creator;
   }

   public Modifier getModifier() {
      return this.modifier;
   }

   public void setModifier(Modifier modifier) {
      this.modifier = modifier;
   }

   public static long getSerialversionuid() {
      return 1L;
   }

   public Integer getPublished() {
      return this.published;
   }

   public void setPublished(Integer published) {
      this.published = published;
   }
}
