package com.huigou.uasp.util;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

public class ReflectionUtil {
   public static Method getSetMethod(Class<?> objectClass, String fieldName) {
      try {
         Class[] parameterTypes = new Class[1];
         Field field = objectClass.getDeclaredField(fieldName);
         parameterTypes[0] = field.getType();
         StringBuffer sb = new StringBuffer();
         sb.append("set");
         sb.append(fieldName.substring(0, 1).toUpperCase());
         sb.append(fieldName.substring(1));
         Method method = objectClass.getMethod(sb.toString(), parameterTypes);
         return method;
      } catch (Exception var6) {
         return null;
      }
   }

   public static Method getGetMethod(Class<?> objectClass, String fieldName) {
      StringBuffer sb = new StringBuffer();
      sb.append("get");
      sb.append(fieldName.substring(0, 1).toUpperCase());
      sb.append(fieldName.substring(1));

      try {
         return objectClass.getMethod(sb.toString());
      } catch (Exception var4) {
         return null;
      }
   }

   public static void invokeSet(Object o, String fieldName, Object value) {
      Method method = getSetMethod(o.getClass(), fieldName);

      try {
         method.invoke(o, value);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

   }

   public static Object invokeGet(Object o, String fieldName) {
      Method method = getGetMethod(o.getClass(), fieldName);

      try {
         return method.invoke(o);
      } catch (Exception var4) {
         var4.printStackTrace();
         return null;
      }
   }
}
